PROGRAM CRCTEST;
{Calculate an incremental CRC over a file}

{$MODE FPC}
USES ECrc32,EFIO;      { EFIO is only used to display a value in HEX form}

CONST FileName='windtest.pp';      {Make sure the file exists}

VAR F           : File;
    Buffer      : ARRAY[0..2047] OF BYTE;       { 2kb buffer}
    BytesRead   : WORD;
    Crc         : CARDINAL;

BEGIN
 IF NOT FileExists(FileName) THEN
  BEGIN
   WriteLn('File doesn'+CHR(39)+'t exist. Rename some file to test.dat');
   HALT;
  END;
 CreateCRC32Table(Poly32);              {Generate the CRC table}
 Assign(F,Filename);
 Reset(F,1);
 CRC:=$0FFFFFFFF;                       {Standard start-value}
 REPEAT
  BlockRead(F,Buffer,2048,BytesRead);   { Read a chunk}
  Crc:=CalcCrc(CRC,Buffer,BytesRead);   { calculate a CRC over the chunk}
 UNTIL BytesRead<>2048;                 { Until end-of-file}
 Close(F);
 WrLngHex(InvertCRC(CRC));               {Invert CRC and display}
 Writeln;
END. {CRCTEST}
