PROGRAM CrToLf;

{ A CrLf filter, tabbing, and other text-file stuff.
                              (C) by Marco van de Voort 1996
  Part of the XTDLIB(/FPC) package.
  See docs/copying.txt for more details.

I use this file to re-tab and re-lf Makefiles after I editted them with a
dos editor. I also use it to make piped man files readable, and under Linux to
avoid problems with dos-edited Tex docs.

The DOS-make is less critical about the format of Makefiles, the Linux version
of make can't handle dos-formatted (#13) textfiles.

}

Uses Dos,EFIO,GetOpts,EPasStr;

TYPE LineSepType= (CrLf,Lf,Cr);
     CHARSET    = SET OF CHAR;

VAR   ToTab       : BOOLEAN;    (* TRUE means spaces to tab, FALSE tab to
                                   spaces *)
      TabLength   : LONGINT;   (* hardtab=8 spaces *)
      LineSep     : LineSepType;(* What do I want? Cr, Lf or CrLf? The other two
                                   are filtered to this. *)
      Wrap        : BOOLEAN;    (* Run the wrapper or the CrLf routine? NI!! *)
      SuppressSep : BOOLEAN;    (* Suppress more than one blank line? *)
                                   (* Not ready *)
      Manpage     : BOOLEAN;
      Rot13       : BOOLEAN;
      WrapSize    : CARDINAL;   (* Wrap to what width?*)
      StripPoints : BOOLEAN;    (* Strip multiple points?*)

CONST CrBufSize=1000;
      TempName  ='TMP.BAK';
      CL        =#13#10;

{$I usage.inc}

      Trigger : CHARSET=[#13,#10,#9,#32,#26];


PROCEDURE OutputUsage;

BEGIN
 WrArrChar(@UsageCrToLf,SIZEOF(UsageCrToLf));
END;

PROCEDURE SpecialWrLn(VAR F:Text);

BEGIN
   CASE LineSep OF     (* make sure that only the right type is flushed*)
    Lf : Write(F,#10);
    Cr : Write(F,#13);
    CrLf: Write(F,#13#10);
    END;
END;

PROCEDURE DoCrToLf(Name1,Name2:String);

VAR F1,F2 : Text;
    C     : CHAR;       (* Current read characted *)
    S     : PCHAR;     (* A buffer for characters to save*)
    InBuf : BOOLEAN;    (* Data in buffer? *)
    X	  : CARDINAL;   (* Position on line, for tabbing *)

PROCEDURE Flush;
(* Flush the buffer when filled*)

VAR A ,B,C2,D,E : CARDINAL;

BEGIN
 IF InBuf THEN
  BEGIN
   IF S[0]=#13  THEN (* #10 never gets in "S", so we don't have to
                           test for it *)
    SpecialWrLn(F2)       (* make sure that only the right type is flushed*)
   ELSE
    IF S[0]=#32 THEN
     BEGIN
      A:=StrLen(S);
      B:=((X) DIV TabLength );       (* B= after which tab we are now.*)
      C2:=((X+A) DIV TabLength );     (* C the is after which tab we'll be after
                                        this operation*)
      IF B<C2 THEN
       BEGIN
        D:=(X+A) MOD TabLength;
//        Write(F2,C2,' ',B,' ',D);
        IF A=1 THEN
         Write(F2,S[0])          (* Don't write one tab instead of only one space*)
        ELSE
         BEGIN
           FOR E :=B TO C2-1 DO Write(F2,#9);
          IF D<>0 THEN
           Write(F2,' ':D);
         END;
       END
      ELSE
       Write(F2,S);      {FOR A:=0 TO StrLen(S)-1 DO Write(F2,S[A]);}
      INC(X,A);
     END
    ELSE
     BEGIN
      A:=StrLen(S);
      IF A<>0 THEN
       BEGIN
        Write (F2,S);
        INC(X,StrLen(S));
       END;
     END;
  END;
  S[0]:=#0; InBuf:=FALSE;  (* Clear buffer*)
END;

VAR A,B : CARDINAL;
    S2  : PathStr;
    HoldChar : BOOLEAN;

BEGIN
 A:=2;
 GetMem(S,CrBufSize);
 IF Length(Name2)=0 THEN
  A:=1;
 Assign(F1,Name1);
 Reset(F1);
 IF A=1 THEN
   Assign(F2,Tempname)
 ELSE
  Assign(F2,Name2);
 Rewrite(F2);
 S[0]:=#0; InBuf:=FALSE;
 X:=0;
 HoldChar:=FALSE;
 REPEAT
   Read(F1,C);
   CASE C OF
     #13 : BEGIN
                IF S[0] <> #13 THEN
                 Flush;
                IF S[0]=#13 THEN
                 BEGIN
                  IF NOT SuppressSep THEN
                   BEGIN
                    B:=StrLen(S);
                    S[B]:=#13; S[B+1]:=#0;
                   END;
                  END
                 ELSE
                  BEGIN
                   X:=0; S[0]:=#13; S[1]:=#0;
                   InBuf:=TRUE;
                  END;
               END;
    #10 :  BEGIN
                IF S[0] <> #13 THEN
                 Flush;
               (* Not important if #13 is in buffer, as long as it's not
                  written*)
                S[0]:=#0; InBuf:=FALSE; X:=0;
                SpecialWrLn(F2);
            END;
     #9  :  BEGIN
             Flush;
             IF ToTab THEN
              BEGIN
               Write(F2,C);
               X:=((X DIV TabLength)+1)*TabLength;
              END
             ELSE
              BEGIN
               B:=TabLength-(X MOD TabLength);
               IF B<>0 THEN
                Write(F2,' ':B);
               INC(X,B);
               END;
          END;
   #26 :     ;
    #32 : BEGIN
              IF ToTab THEN
               BEGIN
                IF S[0] <> #32 THEN
                 Flush;
                B:=StrLen(S);
                S[B]:=#32; S[B+1]:=#0;
                InBuf:=TRUE;
               END
              ELSE
               BEGIN
                Flush;
                Write(F2,' ');
                INC(X);
               END;
          END
   ELSE {CASE}
    BEGIN
     IF Rot13 THEN
      BEGIN
       IF (C>#64) AND (C<#91) THEN
        BEGIN
         C:=CHR(ORD(C)+13);
         IF C>#90 THEN
          C:=CHR(ORD(C)-26)
        END;
       IF (C>#96) AND (C<#123) THEN
        BEGIN
         C:=CHR(ORD(C)+13);
         IF C>#122 THEN
          C:=CHR(ORD(C)-26)
        END;
      END; {Rot13}
     Flush;
     IF Manpage THEN
      BEGIN
       IF HoldChar THEN
        HoldChar:=FALSE
       ELSE
        BEGIN
         IF (C<>#8) THEN
          Write(F2,C)
         ELSE
          HoldChar:=TRUE;
         END;
       END
     ELSE
      Write(F2,C);
    INC(X);
   END;
  END;
 UNTIL EOF(F1);
 Close(F1);
 Close(F2);
 IF A=1 THEN
  BEGIN
   S2:=Name1;
   ChangeExtension(S2,'BAK');
   IF FileExists(S2) THEN
    BEGIN
     Assign(F1,S2);
     Erase(F1);
    END;
   Assign(F1,Name1);    Rename(F1,S2);
   Assign(F1,TempName); Rename(F1,Name1);
  END;
 FreeMem(S,CrBufSize);
END;

PROCEDURE DoParam;

VAR C : CHAR;
    Code : LONGINT;

BEGIN
 ToTab:=FALSE;                   (* Tab spaces *)
 LineSep:=CrLf;                 (* use CrLf as lineseparator*)
 Rot13:=FALSE;                  (* Rot13 off *)
 Manpage:=FALSE;
 TabLength:=8;                  (* tabulators on each 8 characters*)
 StripPoints:=FALSE;            (* Don't strip multiple points to one.*)
 SuppressSep:=FALSE;             (* Never more than one blank line (two
                                   separators) after eachother? *)
 c:=#0;
  repeat
    c:=getopt('clbts:rdm');
    CASE c OF
     'C','c' : LineSep:=Cr;
     'L','l' : LineSep:=Lf;
     'B','b' : LineSep:=CrLf;
     'T','t' : ToTab:=TRUE;
     'S','s' : BEGIN
                Delete(OptArg,1,1);
                Val(optarg,TabLength,Code);
                IF Code<>0 THEN
                 BEGIN
                  Writeln('Error in parameter',OptArg);
                  HALT;
                 END;
               END;
{
     'R','r' : SuppressSep:=TRUE;
     'D','d' : Rot13:=TRUE;
     'M','m' : Manpage:=TRUE;
     '?',':' : BEGIN
                OutPutUsage;
                writeln ('Illegal switch : ',optopt);
               END;}
   end; { case }
 until c=endofoptions;
END;

VAR Param1,Param2 : PathStr;
    P1,P2         : PChar;
    Fl            : BOOLEAN;
    A             : WORD;
    D             : SearchRec;
    F             : File;

BEGIN
 {$IFNDEF Linux}
  Include(Optspecifier,'/');                  {Support / as switcchar under dos}
 {$ENDIF}
 DoParam;
 A:=0;
 if optind<=paramcount then
    begin
    while optind<=paramcount do
      begin
       INC(A);
       IF A=1 THEN
        Param1:=ParamStr(OptInd);
       IF A=2 THEN
        Param2:=ParamStr(OptInd);
      inc(optind)
      end;
    end;
 Writeln('CrToLf 0.01, (C) Marco van de Voort, XtdLib/FPC package'); Writeln;
 IF A<1 THEN
  BEGIN
   OutPutUsage;
   HALT;
  END;

 IF A=2 THEN            {two filenames, wildcards not possible.}
  BEGIN
   IF FileExists(Param1) THEN
    DoCrToLf(Param1,Param2)
   ELSE
    OutPutUsage;
   END
  ELSE
   BEGIN
    A:=RCharPos(Param1,'\');
    IF A=0 THEN
     Param2:=''
    ELSE
     Param2:=Copy(Param1,1,A);
    FindFirst(Param1,AnyFile,D);
    WHILE DosError=0 DO
     BEGIN
      Writeln(Param2+D.Name);
      DoCrToLf(Param2+D.Name,'');
      FindNext(D);
     END;
   END;
 IF FileExists(TempName) THEN
  BEGIN
   Assign(F,TempName);
   Erase(F);
  END;
END.

