program DFree ;

{ File          : DFree.Pas
  name          : DFree
  verson        : 2.3
  author        : Stefan Mensink, CdRom and SUBST support, and drivedetections
                            by Marco van de Voort
  date          : 22 may 1996
  revision date : 10 november 1998.

  description   :

    Shows the available and total diskspace on diskletters C A/m Z, and
    the percentage available/total space. CDRom drives and substituted
    drives are not added to the totals.

  usage :

    dfree

  revision history :
    v2.3: MvdV
      * Better drive-existance system. Avoids unloaded removable drives and
         drive B: renaming.
      * New ExpPath (TRUENAME).
      * Moved all general purpose procedures to libraries, which makes it a
         bit library dependant.
--
      * FPC  Pascal tested. ExpPath doesn't work (yet)
         Exe is 80k (unstripped) 57k (stripped), and probably 30k smartlinked.
--
    v2.2: MvdV
      * Initial SUBST support. Nothing fancy, but working. Uses TRUENAME
         to obtain substed path and displays substed path in white instead
         of volumelabel. Removed the boolean inserted for CDROM's and
         made it an integer (drv) which specifies the drivetype.
      * Starting at drive 1(A:) instead of 3 (C:), seems to work nicely.
      * R = Removable drive.

    v2.1: MvdV
      * Initial CD-rom support. CDROM space is not added
         to the totals, and the free space is how much of the CD is not
         used.(e.g. useful for multi-session CD-writables) Assumes the
         CD is a 650 MB (681 million bytes, Yellow Book?) type. In other
         words, not ready for DvD and other deviating CD types.
         The letters CD are displayed in white before the available space
         if the drive is a CD-drive. Game-CD often contain Red-Book audio,
         which isn't showed in the free bytes window.

    v2.0: SM
      * Shows volume labels.
      * Shows colors.
}
uses

  dos,crt,EDos;

{$I Syseq.inc}

{$IFDEF Go32V2}
(* Undocumented DOS FUNCTION TRUENAME,
   expands a path (in S) to a full path, ignores subst mapping
   (which is used in this program to obtain the substed path)
   and cdrom/network mapping (network drives start with .\\)
   S is converted from ASCIIZ to TP string (length byte updated)
   (e.g. ..\dir\filename.txt to e:\games\dir\filename.txt)

   I advise "S" to be at least 80 characters, standard DOS size path.
   Although undocumented, generally accepted as safe, even by Mickey$oft.
   Always test code with this procedure in it! It is not always accurate as
   you expect it. Specially if you're a 4Dos user or so. *)


FUNCTION int2string (getal, lengte : Double) : STRING ;
(* REAL to string, with comma's on the thousands and left padded
   to lengte *)
  var
    resultaat : STRING ;
    B,C       : INTEGER;

  begin
    Str (getal:0:0, resultaat);
    C:=Length(resultaat);
    FOR B:= 1 TO (C-1) DIV 3 DO Insert(',',resultaat,C+1-3*B);
    while length(resultaat)<lengte do resultaat:=' '+resultaat;
    int2string := resultaat
  end ;

CONST CdSize=681500000; { This can be more concrete. Obtain the nr. of
                          sectors with a int call, and multiply it with
                          512}

var
  teller        : INTEGER;
  S             : STRING ;      { Dummy string for several purposes}

  Free_integer, Total_integer, Perc_integer : Real ;

  TotalFree_integer, TotalTotal_integer, TotalPerc_integer:Double;
  TotalFree_string,  TotalTotal_string,  TotalPerc_string:String;

  balk:String;
  i   :Integer;
  Drv : INTEGER;

{$ENDIF}

begin
 {$IFDEF Go32v2}
  teller := 1;
  textcolor(green);
  Write (' -=[ '); textcolor(lightgreen);
  Write ('DFree v2.3'); textcolor(green);
  Writeln ('  Written by: Crusher ^ inzeen!phorze and MvdV ]=-');
  TextColor(White);     Write('  CD');
  TextColor(LightGray); Write ( '= CDROM drive  ');
  TextColor(White);     Write('  R ');
  TextColor(LightGray); WriteLn ( '= Removable drive  ');

  textcolor(lightblue);
  WriteLn (''
             +'Ŀ');
  Write (' '); textcolor(yellow);
  Write ('drive + label'); textcolor(lightblue);
  Write ('   '); textcolor(yellow);
  Write ('   bytes free'); textcolor(lightblue);
  Write ('  '); textcolor(yellow);
  Write ('  volume size'); textcolor(lightblue);
  Write ('  '); textcolor(yellow);
  Write ('Percentage used'); textcolor(lightblue);
  WriteLn ('           ');
  WriteLn (''
          +'Ĵ');

  repeat
   Drv:=DriveType(Teller);
   IF Drv<>0 THEN
    BEGIN
      Free_Integer:=DiskFree(Teller);
        IF Drv<4 THEN {free space on Cdroms and Subst not in totals}
         TotalFree_integer:=TotalFree_integer+Free_integer;
        S:=Chr(teller+64)+': ';
        Write (' ');
        textcolor(lightgray);      Write (S) ;
        IF Drv <>4 THEN
         Write (GetVolume(Teller))
        ELSE
         BEGIN
          S:=chr(teller+64)+':\'+CHR(0); {Old hack to get SUBST path}
          TRUENAME(S);
          I:=ORD(S[0]);
          IF I<11 THEN
           FOR I :=I TO 11 DO S[I]:=CHR(32);
          IF I>12 THEN
           I:=12;
          S[0]:=CHR(I);
          TextColor(White);
          Write(S);
         END;
        textcolor(lightblue); Write (' ');
        Total_integer := DiskSize (teller) ;
        I:=13; TextColor(White);
        IF Drv=5 THEN
         BEGIN
          Write('CD');
          Free_integer:=CdSize-Total_integer;
          Total_integer:=cdsize;
          DEC(I,2);
         END;
        IF Drv=3 THEN
         BEGIN
          Write('R');
          DEC(I,1);
         END;
        IF Drv<4 THEN { Don't count SUBST and CDROM drives in totals}
         TotalTotal_integer:=TotalTotal_integer+Total_integer;
        S := int2string (Free_integer, I) ;
        textcolor (lightgray);          Write (' ',S);
        textcolor (lightblue);          Write ('  ');
        S := int2string (Total_integer, 13) ;
        textcolor (lightgray);     Write (S);
        textcolor (lightblue);     Write ('  ') ;
        Perc_integer := 100 - round ((Free_integer / Total_integer) * 100);
        S := int2string (Perc_integer, 3) ;
        balk:='';
        for i:=1 to (round(Perc_integer) div 5) do
         balk:=balk+'';
        while length(balk)<20 do
         balk:=balk+'';
        textcolor (lightgray);     Write   (S, '% ', balk);
        textcolor (lightblue);     WriteLn (' ') ;
        END;
    INC(teller);
  until teller = 27;
  WriteLn(''+
          'Ĵ');
  TotalFree_string := int2string (TotalFree_integer, 13) ;

  Write (' ');
  textcolor (lightgray);         Write ('-: Total       ');
  textcolor (lightblue);         Write (' ') ;
  textcolor (lightgray);         Write (TotalFree_string);
  textcolor (lightblue);         Write ('  ') ;
  TotalTotal_string := int2string (TotalTotal_integer, 13) ;
  textcolor (lightgray);         Write (TotalTotal_string);
  textcolor (lightblue);         Write ('  ') ;
  TotalPerc_integer := 100 - round ((TotalFree_integer / TotalTotal_integer)
   * 100) ;
  TotalPerc_string := int2string (TotalPerc_integer, 3) ;

  balk:='';
  for i:=1 to (round(TotalPerc_integer) div 5) do
   balk:=balk+'';
  while length(balk)<20 do
   balk:=balk+'';
  textcolor (lightgray);         Write (TotalPerc_string, '% ', balk);
  textcolor (lightblue);         WriteLn (' ') ;
  Write(''
           +'');
  textcolor(lightgray);          WriteLn;
  {$ENDIF}
end. {DFREE}

