PROGRAM DirTest;
{ DirTest. A demonstration(actually, a test) of the tree-building capabilities
    of EDirTree.

Part of the XTDLIB/FPK package.}

Uses EDirTree,Dos;

{ PROCEDURES passed to other procedures have to be declared FAR.
   No effect in FPK according to the help}

PROCEDURE ReportDir(P :pathstr); FAR;
{Called for every directory encountered when scanning the tree, if DirsToo=
    TRUE
 Directory in P (Procedure ScanTree)}

BEGIN
 { Do nothing}
END;

PROCEDURE ReportFile(Path :pathstr;Search:SearchRec); FAR;
{Called for every file encountered when scanning the tree.
 Directory in P, filename Search.Name (Procedure ScanTree)}

BEGIN
 IF (Search.Attr AND Directory)<>0 THEN { Never true}
  Writeln(' Grr, this isn'+CHR(39)+'t a file but a directory');
 Writeln(Path+Search.Name);
END;

FUNCTION Detector(Search:SearchRec;P:PathStr):BOOLEAN; FAR;
{ Possibility to select files when scanning. Put a ARJ detection here, or
  a MOD detection whatever you want, as long as it returns TRUE when you want
  the file in the tree, and FALSE otherwise}

BEGIN
 Detector:=Search.size>50;    (* Select all files larger than 50 bytes*)
END;

CONST Searchme='\';

VAR Root : DirTreePoint;

BEGIN
 writeln('Memory available before start :',memAvail);  { Write free heap}
 Root:=BuildTree(Searchme);             { Scan directories, and create tree}
 writeln('Memory free after building directorystructure:',memAvail);
 { The below example is stupid, but done to explain that you can call
 SearchForFiles more than one time.

 A smarter way would be to scan for *.*, and check the extension in detector,
 that way you could scan both types of files in one run}
 SearchForFiles(Root,'*.pas',@Detector); { Added all .PAS files bigger than
                                          50 bytes to tree}

 SearchForFiles(Root,'*.pp',@Detector);  { same for .PP (FPK-pascal) files}


 writeln('Memory after adding files:',memAvail);

 ScanTree(Root,@ReportFile,@ReportDir);   { Process (write in this case) tree}
 KillFileTree(Root);                    { Remove tree from memory}
 writeln('Memory free after cleaning :',memAvail);
END.
