PROGRAM LfnTest;
{Requires _no_ RTL, may be compiled with RTL-lite, but not without my
units :-}

Uses Dos,Go32;

procedure LFN_to_DOSname(lfn : string; var dosname : string);
var r : registers;
    curchar, i, dos_addr : DWord;
begin
    if ((LFNsupport) and (tb_size >= 522)) then
     begin

       { clear the area with #0's for the interrupt }

       seg_memset(fseg, tb_address, byte(lfn[0]) + 15, 0);

       { calculate offset from the start of the transfer buffer where we 
         can store the DOS filename }

       dos_addr := tb_address + byte(lfn[0]) + 1;

       { copy long file-name to transfer buffer }

       seg_memcpy(dseg, dword(@lfn)+1, fseg, tb_address, byte(lfn[0]));

       { patch it to a ASCIIZ string :}

       dmemb[tb_address + byte(lfn[0])] := 0;
       { issue the interrupt }
       r.eax := $71A8; { the edx = $0100 function is buggy (DOS) !
                         We need to use edx = $0011 instead, which
                         returns the filename in FCB format. (filename = 8
                         chars + 3 chars extension, unused chars filled up
                         with #32' }
       r.edx := $0011;
       { some address calculation }
       r.ds := tb_address shr 4;
       r.esi := tb_address and $0f;
       r.es := dos_addr shr 4;
       r.edi := dos_addr and $0f;
       realintr($21, r);
       { check for error }
       if ((r.flags and fCarry) <> 0) then 
          Writeln('Conversion failed; DOS Error : ', r.ax, ' occured');
       { convert the ASCIIZ in FCB format to a string }
       curchar := 1;
       for i := 0 to 7 do
           if (dmemb[dos_addr + i] <> 32) then begin
              dosname[curchar] := char(dmemb[dos_addr + i]);
              curchar := curchar + 1;
           end;
       dosname[curchar] := '.';
       curchar := curchar + 1;
       for i := 8 to 10 do
           if (dmemb[dos_addr + i] <> 32) then begin
               dosname[curchar] := char(dmemb[dos_addr + i]);
               curchar := curchar + 1;
           end;
       { patch length of DOS name }
       dosname[0] := char(curchar - 1);
    end else begin
        dosname := lfn;
    end;
end;

VAR dosname, longname : String;

BEGIN
     dosname := '';
     longname := 'this is a long file.text';
     LFN_to_DOSname(longname, dosname);
     Writeln('DOS name length : ', byte(dosname[0]));
     Writeln('New DOS name : ', dosname);
END.

