PROGRAM File2Tag;
{ A real time saver. Uses EDirTree and various other units, XtdLib package,
                              (C) by Marco van de Voort 1996

Fixes MP3 tags of trees of MP3 files.

Prerequisite: MP3 file named according to my convention:

 "Artist - Albumname"\"## Artist - ##[-] songname.mp3"

Where ## can be a the song number or empty. (1 char songnumbers also supported)
a second dash or a point between songnumber and songname is allowed.

The field updated, are as you can already see in the convention Artist, Songname
and album name. If a songnumber is found, it's copied to the comment field
with nr. in front of it. If no number is found, the comment tag is untouched.

There is a switch -a "albumname" which sets a different albumname.

use -a "" (no space) to leave albumname untouched, or -a " " (one or more
spaces) to clear it.

INITIAL VERSION, so try effect on small trees (single directories with backup)
first!

}

Uses eMp3,EPasStr,EDirTree,Dos,Strings,GetOpts,EFIO;

{$I usage.inc} {Usages text from devel/usage.txt}

FUNCTION TryNumber( VAR S: String;Position : LONGINT):LONGINT;

VAR Value : LONGINT;
    Count : LONGINT;

BEGIN
 Value:=0; Count:=0;
 WHILE (S[Position+Count]>#47) AND (S[Position+Count]<#58) DO
  BEGIN
   Value:=Value*10; Value:=Value+ORD(S[Position+Count])-48;
   INC(Count);
  END;

 IF (Count>0) AND ((Count<3) AND (S[Position+Count] IN [' ','.','-'])) THEN
  BEGIN
   Delete(S,Position,Count);
   TryNumber:=Value;
  END
 ELSE
  Trynumber:=-1;
END;

VAR DOAlbum : BOOLEAN;
    AlbumName : String;

PROCEDURE FixMp3Tag(Dir:PathStr;Fil:SearchRec);

VAR Tag  : ID3Tag;
    S,S2 : String;
    I    : LONGINT;

BEGIN
 IF GetTag(Dir+Fil.Name,Tag)<2 THEN   {Tag present or not, but no error occured}
  BEGIN
   I:=Pos(' - ',Fil.Name)+1;
   IF I<>0 THEN
    BEGIN
     Tag.Artist:=Copy(Fil.Name,1,I-1);
     RTrim(Tag.Artist,' ');
     IF Fil.Name[I+1]=' ' THEN
      INC(I,2);
     Tag.SongName:=Copy(Fil.Name,I,Length(Fil.Name)-I-3); { -4 =".mp3"}
     IF DoAlbum THEN
      BEGIN
       S:=FExpand(Dir);
       DEC(S[0]);         {Remove trailing \}
       I:=RCharPos(S,'\');
       IF I<>0 THEN
        Delete(S,1,I);
  
       I:=CharPos(S,'-');
       IF I<>0 THEN
        Delete(S,1,I);            {Cut out albumname from path}
       Writeln('Album :',S);
       LTrim(S,' ');
       RTrim(S,' ');
       Tag.Album:=S;
      END
     ELSE
      BEGIN
       IF AlbumName<>'' THEN
        Tag.Album:=AlbumName;
      END;
     I:=TryNumber(Tag.Artist,1);
     IF I<>-1 THEN
      BEGIN
       KillChar(Tag.Artist,['-','.',' ']);
       Str(I,TAG.Comment);
       Insert('Nr. ',TAG.Comment,1);
      END;
     I:=TryNumber(Tag.SongName,1);
     IF I<>-1 THEN
      BEGIN
       KillChar(Tag.SongName,['-','.',' ']);
       Str(I,TAG.Comment);
       Insert('Nr. ',TAG.Comment,1);
      END;
     SetTag(Dir+Fil.Name,Tag);
    END;
  END;
END;

PROCEDURE DoParam;

VAR C : CHAR;

BEGIN
 c:=#0;
  repeat
    c:=getopt('?A:a:');
    CASE c OF
     'A','a' : BEGIN
                DoAlbum:=FALSE;
                AlbumName:=OptArg;
               END;
     '?',':' : BEGIN
                Writeln('File2Tag v0.01 (C) 1999 by Marco van de Voort LGPL');
                WrArrChar(@UsageFile2Tag,SIZEOF(UsageFile2Tag));
                IF C<>'?' THEN
                 writeln ('Illegal switch : ',optopt);
                HALT;
               END;
   end; { case }
 until c=endofoptions;
END;

VAR P1,P2 : PChar;

BEGIN
 DoAlbum:=TRUE;
 DoParam;
 GetMem(P1,150);  GetMem(P2,150);
 StrPCopy(P1,'.');  StrPCopy(P2,'*.mp3');
 EDirTree.FileScan(P1,P2,@FixMp3Tag);
END.
