PROGRAM FileFinder;
{ A demonstration of module EDirTree, XtdLib package,
                              (C) by Marco van de Voort 1996

A kind of FileFind system, with a demonstation of Crt's capabilities to change
the Crt system from normal (dos writes) to direct screenwriting and vice versa.
It's used here to make the real output pipeable to a file, while system
and error messages still appear on the screen.

Should be made totally DOS redirection and pipe aware. (with a special switch?)

(0.09?) Now pipable, eliminated Crt
(0.13)  Revised, some switches (long, short). Needed it to create playlists for
        WinAmp. (filefind -i c:\directory *.mp3 |sort > Playlist.m3u ^ start playlist.m3u)
        P.s. I use a modified dos-unit. I put a IF NOT LFNSupport THEN before the
        UPCASE command in FExpand to avoid losing case information.
}



Uses EDirTree,Dos,Strings,GetOpts,EFIO,EDOS;

{$I usage.inc}

CONST CR=CHR(13)+CHR(10);

ProgHdr='FileFinder 0.0002, (C) Marco van de Voort, XtdFPC package'+CR+CR;

{$IFDEF Linux}
 WildCardReminder=CR+'Please remind that under Linux wildcards have to be quoted,'+CR+
                     ' otherwise the shell will expand them before passing them to Filefind.'+CR+CR;
{$ENDIF}

VAR Ver7 : BOOLEAN;
    OtherStat     : BOOLEAN;

PROCEDURE ShowRecord(Dir:PathStr;Fil:SearchRec); FAR;

VAR S : PathStr;

BEGIN
 S:=Dir+Fil.Name;
{$IFNDEF Linux}
 IF NOT Ver7 THEN
  BEGIN
   GetShortPathName (Dir+Fil.Name,S);
   Writeln(S);
  END
 ELSE
  BEGIN
{$ENDIF}
   S:=FExpand(S);
   Writeln(S);
{$IFNDEF Linux}
  END;
{$ENDIF}
END;{ ShowRecord;}

PROCEDURE DoParam;

VAR C : CHAR;

BEGIN
 c:=#0;
  repeat
    c:=getopt('il?');
    CASE c OF
     'I','i' : OtherStat:=FALSE;
     'L','l' : Ver7:=FALSE;
     '?',':' : BEGIN
                Write(ProgHdr);
                WrArrChar(@UsageFileFind,SIZEOF(UsageFileFind));
                {$IFDEF Linux}
                 Write(WildCardReminder);
                {$ENDIF}
                IF C<>'?' THEN
                 writeln ('Illegal switch : ',optopt);
                HALT;
               END;
   end; { case }
 until c=endofoptions;
END;

VAR Param1,Param2 : PathStr;
    P1,P2         : PChar;
    Fl            : BOOLEAN;
    A             : WORD;

BEGIN
 OtherStat:=TRUE;
 Include(Optspecifier,'/');                  {Support / as switcchar}
 Ver7:=TRUE;                                 {Support for longfilenames}
 DoParam;
 A:=0;
 if optind<=paramcount then
    begin
    while optind<=paramcount do
      begin
       INC(A);
       IF A=1 THEN
        Param1:=ParamStr(OptInd);
       IF A=2 THEN
        Param2:=ParamStr(OptInd);
      inc(optind)
      end;
    end;
 IF OtherStat THEN
   Write(ProgHdr);
 IF A<2 THEN
  BEGIN
   IF OtherStat THEN
    BEGIN
     WrArrChar(@UsageFileFind,SIZEOF(UsageFileFind));
     {$IFDEF Linux}
      Write(WildCardReminder);
     {$ENDIF}
     Writeln (' Not enough parameters');
    END;
   HALT;
  END;
 IF OtherStat THEN
  BEGIN
   FOR A:=1 TO 78 DO Write('-');
   Writeln;
  END;
 EDirTree.DirsToo:=FALSE;
 FExpand(Param1); (* Simplify the path, ..\ .\ etc are expanded,
                         makes scan a lot more robust, *)
 GetMem(P1,150);  GetMem(P2,150);
 StrPCopy(P1,Param1);  StrPCopy(P2,Param2);
 EDirTree.FileScan(P1,P2,@ShowRecord);
 IF OtherStat THEN
  BEGIN
   FOR A:=1 TO 78 DO Write('-');
   Writeln;
   Writeln;
   Write(EDirTree.FoundCount:5); Write(' files, ');
   Write(EDirTree.TotalBytes:12); Writeln(' bytes');
   Writeln;
  END;
 FreeMem(P1,150);  FreeMem(P2,150);
END.
