PROGRAM FindArch;
{Scans in current-directory and below for archive files, and other known files.
  Not dependant on extensions for archive-detection.

  Used to have only one problem, which seems to be fixed in newer versions
  (Did LFN FindFirst and FirstNext fix the problem?)
  EDirTree can't avoid very exclusive locking of swapfile windows, and/or some
  other locking mechanisms, will runtime error 5 when it's encounterd}

USES EDirTree,EFIO,Dos;

VAR
    ArchivesFnd : WORD;

PROCEDURE Print (Path : Pathstr; Rec : Searchrec); FAR;

VAR AType : ArchiveType;
    A     : LONGINT;

BEGIN
 AType:=ArchiveMethod(Path+Rec.Name);
 IF  AType>None THEN
  BEGIN
   INC(ArchivesFnd,1);
   Write (ArchivesFnd:4,' Found : ',path+Rec.name);
   A:=40-Length(Path)-Length(Rec.Name);
   IF A<=0 THEN A:=1;
   Write(' ':A,' Type:');
   CASE AType OF
    SQZ :          writeln('SQZ');
    ZIP :          writeln('ZIP');
    HPK :          writeln('HPK');
    ZOO :          writeln('ZOO');
    LZH :          writeln('LZH');
    ARJ :          writeln('ARJ');
    DWC :          writeln('DWC');     {Detection not working yet}
    ARC :          writeln('ARC');     {Detection not working yet}
    PAK :          writeln('PAK');     {Detection not working yet}
    A7P :          writeln('A7P');     {Detection not working yet}
    HYP :          writeln('HYP');     {Detection not working yet}
    RAR :          writeln('RAR');
    Q  :           writeln('Q');
    UC2 :          writeln('UC2');
    GIF :          writeln('GIF');
    LBM :          writeln('LBM');
    PCX :          writeln('PCX');
    WAV :          writeln('WAV');
    BMP :          writeln('BMP');
   ELSE
    Writeln('Unknown format (probably supported by ArchiveMethod, but not by FindArch)');
   END; {Case}
 END; {IF}

END; {Print}

Begin
  dirstoo:=FALSE;                    { Don't report directories, cause
                                       ArchiveMethod hates it}
  edirtree.setfattr(anyfile-volumeid); { Don't report volumeIDs}
  FileScan ('.','*.*',@print);
end.
