PROGRAM FixMp3Conventions;
{ Another MP3 maintenance util.   Uses EFIO, EPasStr, XtdLib package,
                              (C) by Marco van de Voort 1996

Used for MP3 maintenance, but maybe more people with cds from the time
that spaces were not done under Linux can use it.

The unix convention for MP3s is still something like:

the.artist-the.song.mp3  probably because more akward unix systems don't allow
spaces, and because of the generic avoidance of uppercase characters, even
if they are functional.

This quick-and-dirty program reads the output of filefind (or unix find command
if you can memorize the 20 switches) from a file (so not from a pipe).
Then it creates a batchfile, roughly like this:

ren "the.artist-the.song_about_world.mp3" "The Artist - The Song About World.mp3"
for all files in the inputfile.

In the inputfile you can also specify the source paths and destination paths with
@1 and @2

@1i:\
@2d:\mp3\newstuff
asdf.dfas.dfsa.dfas.mp3

Will generate

ren "i:\asdf.dfas.dfsa.dfas.mp3" "d:\mp3\newstuff\Asdf Dfas Dfsa Dfas.mp3"

You can use more than one @1 or @2, and if your input file already has sourcepaths
d:\asdf.dfas.dfsa.dfas.mp3
the sourcepath isn't prepended (I believe).

I include this in XTDFPC, since this is the kind op programs I make most. A bit
more than an average shellscript, but not much. A veteran script write maybe
could even do this with SED or so. Pascal is clear and structured though.

Most files (in the demo directory) fall into this category. Simple maintenance
semi-intelligent robot work. To me, these small programs have always been more
rewarding than the big ones (except QuoCount maybe). They don't cost to much
time (if you have some libraries) to create, and avoid a lot brainless work.

Also the files can be used as a kind of template, which can be clearly seen in
this directory with its 3 or 4 FileFind derivatives.
}

Uses EFIO,EPasStr;


PROCEDURE FixStr(VAR  S :String);

VAR I,J : LONGINT;

PROCEDURE FixExtension(SearchArg: String);

BEGIN
 I:=Pos(SearchArg,S);
 IF (I<>0) AND (S[I-1]=' ') THEN
   S[I-1]:='.';
 IF (I<>0) AND (S[I-1]='_') THEN
   S[I-1]:='.';
END;

BEGIN
 I:=CharPos(S,'-');
 IF I<>0 THEN
  BEGIN
   IF NOT (S[I+1] IN ['.',' ']) THEN
    Insert(' ',S,I+1);
   IF NOT (S[I-1] IN ['.',' ']) THEN
    Insert(' ',S,I);
  END;
 I:=Length(S);
 J:=1;
 IF (S[1]>#96) AND (S[1]<#125) THEN
     DEC(S[1],32);
 WHILE J<=I DO
  BEGIN
   IF S[J]='.' THEN
    S[J]:=' ';
   IF S[J]=' ' THEN
    IF (S[J+1]>#96) AND (S[J+1]<#125) THEN
     DEC(S[J+1],32);
   INC(J);
  END;
 I:=Pos('MP3',S);
 IF I<>0 THEN
  IF S[I-1]=' ' THEN
   S[I-1]:='.';
 FixExtension('MP3');
 FixExtension('Mp3');
END;

PROCEDURE FixStr2(VAR  S :String);
{Unused procedure, alternative to fixstr. Fixes a different kind of conventon:
 "TheArtist_SongAboutTheWorld.mp3" -> "The Artist - The Song About World.mp3",

this convention is rarer than the Unix convention which is corrected by FixStr}

VAR S2 : String;
    I,J : LONGINT;

BEGIN
 I:=2; J:=2;
 S2[1]:=S[1];
 WHILE I<=Length(S) DO
  BEGIN
   IF (ORD(S[I])>64) and (ORD(S[I])<91) THEN
    begin
     s2[j]:=' '; inc(j);
    end;
   IF S[i]='_' THEN
    BEGIN
     S2[j]:=' '; S2[j+1]:='-'; S2[J+2]:=' '; INC(J,3);
    END
   ELSE
    BEGIN
     S2[j]:=S[i];
     INC(J);
    END;
  INC(I);
  END;
 S2[0]:=CHR(J-1);
 S:=S2;
END;

VAR F1,F2 : Text;
    S,S2  : String;
    FromPath,
    ToPath : String;
    A : LONGINT;

BEGIN
 IF ParamCount<1 THEN
  HALT;
 S:=ParamStr(1);
 IF NOT FileExists(S) THEN
  HALT;
 Assign(F1,S);
 Reset(F1);
 Assign(F2,'doit.bat');
 Rewrite(F2);
 REPEAT
  ReadLn(F1,S);
  IF S[1]='@' THEN
   BEGIN
    CASE S[2] OF
    '1' : BEGIN
	   FromPath:=S;
	   Delete(FromPath,1,2);
	   AppendBackSlash(FromPath);
	  END;
    '2' : BEGIN
	   ToPath:=S;
	   Delete(ToPath,1,2);
	   AppendBackSlash(ToPath);
	  END;
      END;
   END
  ELSE
   BEGIN
  IF Length(S)>3 THEN
   BEGIN
    S2:='ren "';
    A:=RCharPos(S,'\');
    IF A=0 THEN
     S2:=S2+Frompath;
    S2:=S2+S+'" ';
    RGrow(S2,' ',70);
    IF A<>0 THEN
     Delete(S,1,A);
    FixStr(S);
    Writeln(F2,S2,'"',ToPath,S,'"','   >>error.log');
   END;
  END;
 UNTIL EOF(F1);
 Close(F1);		
 Close(F2);
END.

