PROGRAM Indexer;

{ Another demonstration of module DirTree, XtdLib package,
			      (C) by Marco van de Voort 1996-98

OOP version

Severely different from Modula-2 version. Doesn't scan descript.ion's for now,
since the LFN system is easier in FPC. Descript.ion support will be built in
later again, but more configurable, and different from the M2-version. It will
be a LFN scan, which gets descriptions added afterwards, probably at the point
before the sort-procedure. The index shows the descriptions only for short
filenames.
Also I want to redo the descript.ion part allowing multiple input sources
(add 00_index.txt).

Main description:
-----------------

The program assumes that the directory specified as the first
parameter, or if not specified, the current directory is the starting point
for a CD, and generates a file index.txt in the current directory.

The index contains all files per directory. It sorts all files in a directory,
moving directories to the front, but not the directories self. You could use a
suitable dirsorter first.

Ultimate goal is an automatic generating index-system like on Walnutt Creek CDs,
I've purchased a WC Simtel CD a few times, and it turned out to be the best
indexed CD I've ever seen. In fact, I stopped buying cheap cdroms (except for
some Doom-levels), but as far as shareware CDs are concerned, choose vendors as
Walnutt Creek and InfoMagic. 3 times as expensive, but 100 times as good.

This initial version works, but to obtain a nice output :
    - Run a directory sorter (like nortons disksort) to get the directories
      alphabetically sorted. If you don't own Norton, you could run a disk
      defragger, DOS 6.x has one included. Most disk-defraggers have file-sort
      directories included. (Except Windless '95 of course...)
      A shareware dirsorter for Win95 is also available. It couldn't sort a
      partition with a lot (48000) files, but for smaller numbers (<15000) it
      works fine. NEVER USE A DOS 6.x DIRSORTER ON A WINDOWS '95 PARTITION!

      Only the directory names have to be sorted. The filenames are sorted
      by the program.
    - This version is not very robust, remove garbadge from descript.ion's
       when necessary. QPV comments are already deleted automatically.

For a nice product some things should be improved :

- Support for fileattributes, scan only archive/ not hidden etc files,
    and filename include/exclude specs.
- A setupfile, where to read descriptions from, and what to create.
- HTML and 00_index.txt support, problem is that directory structures exist
   in these files, so the simple procedure executed here is not enough.
  The more complex Tree-procedures of EDirTree could be used for this, but
  I'll try a FileScan construct first, using a file for each (recursion) level
  approach. Simpler, and not as memory hungry.
- Combining indexes. e.g. start with FILES.BBS, en add all nonmatches from
  descript.ion.
- Get all files, with a certain pattern (Wildcard(s)), and put them in a list
   with no description, and resort.
- A switch which puts everything forced in LFN  or SFN (with descriptions) mode.
    Now you have LFN files, with sometimes a SFN file inbetween.
- Block certain files from the list (descript.ion, index.txt, files.bbs etc)

}
Uses Crt,Dos,Strings,eDirTree,EPasStr;

TYPE DirEPoint  =    ^DirERec;
     DirERec    =    RECORD
		      Next  : DirEPoint;
		      DirE  : SearchRec;
		      END;


VAR MainDir : String;
    MainF   : Text;

PROCEDURE SortDescrTree(Root:DirEPoint;Nr : CARDINAL);
{ A bubble sorter I'm afraid, since I never figured out smarter way to
    sort a single linked tree. }

VAR A	   : CARDINAL;
    Cur,Cur2    : DirEPoint;
    Rec	 : DirERec;
    Fl,Fl2      : BOOLEAN;
    S,S2	: String;

PROCEDURE SwapRec;

BEGIN
      Rec:=Cur^;
      Cur^.DirE:=Cur2^.DirE;
      Cur2^.DirE:=Rec.DirE;
END;

BEGIN
 FOR A:=1 TO Nr DO
  BEGIN
   IF Root^.Next <> NIL THEN
    BEGIN
     Cur:=Root;
     Cur2:=Cur^.Next;
     IF Cur2^.Next<>NIL THEN
      REPEAT
       Fl:=(Cur^.DirE.attr AND directory)>0;
       Fl2:=(Cur2^.DirE.attr AND directory)>0;
       IF (Fl AND Fl2) OR (NOT ( Fl OR Fl2)) THEN
	BEGIN
	 S:=Cur^.DirE.Name;     Uppercase(S);
	 S2:=Cur2^.DirE.Name;   Uppercase(S2);
	 IF S>S2 THEN
	  SwapRec
	 END
	ELSE
	 IF Fl2 THEN
	  SwapRec;
       Cur:=Cur^.Next;
       Cur2:=Cur^.Next;
      UNTIL (Cur2^.Next=NIL) OR (Cur^.Next=NIL);
    END;
  END;
END;

PROCEDURE WrStrAdj(VAR F: Text;CONST InS: String;L : LONGINT);

VAR Len,I : LONGINT;


BEGIN
 Len:=Length(InS);
 IF Len>=ABS(L) THEN
  Write(F,InS)
 ELSE
  IF L<0 THEN
   BEGIN
    Write(F,inS);
    FOR I:= 1 TO (ABS(L)-Len) DO Write(F,' ');
   END
 ELSE
  BEGIN
   FOR I:= 1 TO (ABS(L)-Len) DO Write(F,' ');
    Write(F,inS);
  END;
END;

PROCEDURE ShowRecord(Dir:PathStr;Fil:SearchRec);

VAR S2	   : String;
    Root, Cur   : DirEPoint;
    Descrs      : CARDINAL;
    Fl	  : BOOLEAN;
    I	   : INTEGER;
    TT	  : SearchRec;
    IsDir       : BOOLEAN;


CONST DDe='\descript.ion';

BEGIN
{ IF (Fil.Attr AND Directory)>0 THEN
  BEGIN}
     writeln(Dir);			  {Let see what directory we're working on}
     S2:=Dir;
     AppendBackSlash(S2);		{Safer than S2=Dir+'\*.*'}
     S2:=S2+'*.*';
     WriteLn(MainF); WriteLn(MainF);
     Writeln(MainF,Dir); Writeln(MainF);
     NEW(Root);
     Cur:=Root;
     Cur^.Next:=NIL;
     Descrs:=0;
     FindFirst(S2,Anyfile,TT);
     IF DosError=0 THEN
      BEGIN
	Writeln(MainF);
	WHILE DosError=0 DO
	 BEGIN
	  IF TT.Name[1]<>'.' THEN
	   BEGIN
	    NEW(Cur^.Next);
	    Cur^.DirE:=TT;
	    Cur:=Cur^.Next;
	    Cur^.Next:=NIL;
	    INC(Descrs);
	   END; {IF}
	  FindNext(TT);
	 END; {While}
       END; {IF}
      SortDescrTree(Root,Descrs);
      Cur:=Root; Fl:=TRUE;
      REPEAT
       IsDir:= (Cur^.DirE.attr AND Directory)>0;
       IF NOT IsDir THEN     { Linefeed after directories}
	BEGIN
	 IF Fl THEN
	  Writeln(MainF);
	 Fl:=FALSE;
	END;
       IF (Cur^.DirE.attr AND Hidden)=0 THEN
	BEGIN
{	 IF Length(Cur^.DirE.Name)<=15 THEN
	  I:=-15			    {Signal to get the description}
	 ELSE}
	  I:=-68;
	 IF NOT IsDir THEN
	  BEGIN
	   WrStrAdj(MainF,Cur^.DirE.Name,I);
	   Write   (MainF,Cur^.DirE.size:10);
	  END
	 ELSE
	  BEGIN      { Special treatment for directories}
	   ItemS (S2,Cur^.DirE.Name,'-',0);
	   WrStrAdj(MainF,S2,-40);
	   ItemS (S2,Cur^.DirE.Name,'-',1);
	   WrStrAdj(MainF,S2,-40);
	   Write(MainF,' ':10);
	  END;
	 IF I=-15 THEN
	  BEGIN
	   {N/A yet}
	  END;
	 Writeln(MainF);
	 END; {IF Hidden}
       IsDir:=Cur^.Next=NIL;
       Cur:=Cur^.Next;
       UNTIL IsDir OR (Cur^.Next=NIL);
{    END;}
END;

CONST CR=CHR(13)+CHR(10);
      Usage=
 'Creates indexes and Files.bbs from descript.ion, recursing directories.'+CR+
 'Usage : Indexer <Starting-Directory> '+CR+
 '      E.g. Indexer c:..\source'+CR+CR;

VAR Param1	: PathStr; { Size of string is important,
					       see notes about ExpPath in
					       ELib.DEF or in the Help }
    P,P2	   : PCHAR;

BEGIN
 Crt.TextColor(Crt.Yellow);
 Writeln('Indexer 0.0002, (C) Marco van de Voort, XtdLib package');
 Crt.TextColor(Crt.LightGray);
 WriteLn;
 Param1:=ParamStr(1);     { Empty path is expanded}
 Param1:=FExpand(Param1);
 MainDir:=Param1;
 AppendBackSlash(MainDir);
{ MainDir:=MainDir+'index.txt';}
 MainDir:='C:\index.txt';
 Assign(MainF,MainDir);
 Rewrite(MainF);
 EDirTree.DirsToo:=TRUE;
 GetMem(P,255);  GetMem(P2,255);
 StrPCopy(P,Param1); StrCopy(P2,'.');
 EDirTree.FileScan(P,P2,@ShowRecord);
 Close(MainF);
END.
