PROGRAM ODirTest;
{ ODirTest. An OOP demonstration/test of the tree-building capabilities
    of ODirTree.

Part of the XTDLIB/FPC package.}

{$MODE objfpc}

Uses ODirTree,Dos;

{ PROCEDURES passed to other procedures have to be declared FAR.
   No effect in FPK according to the help}

TYPE TreeTest = CLASS (TTreeScan) {define and override all abstact methods}
                  PUBLIC
                   Filez : ARRAY[0..15] OF Text;
                  FUNCTION  CreateObject       (Path : PathStr;Search: SearchRec):POINTER; OVERRIDE;
                  PROCEDURE FreeObject       (VAR Obj : POINTER); OVERRIDE;
                  PROCEDURE BuildDirEnter  (Path : PathStr); OVERRIDE;
                  FUNCTION  BuildDetect    (Search:SearchRec;P:PathStr):BOOLEAN; OVERRIDE;
                  PROCEDURE BuildDirExit   (Path : PathStr); OVERRIDE;
                  PROCEDURE ScanDirEnter  (Path : PathStr); OVERRIDE;
                  PROCEDURE FileFound (Path : PathStr;VAR Search : SearchRec;VAR UserPtr:POINTER); OVERRIDE;
                  PROCEDURE ScanDirExit   (Path : PathStr); OVERRIDE;
                  END;

FUNCTION  TreeTest.CreateObject       (Path : PathStr;Search: SearchRec):POINTER;
BEGIN
 CreateObject:=NIL;     {Important. NIL is the signal not to try to dispose
                            UserData}
END;

PROCEDURE TreeTest.FreeObject       (VAR Obj : POINTER);
BEGIN
END;

PROCEDURE TreeTest.BuildDirEnter  (Path : PathStr);
BEGIN
END;

PROCEDURE TreeTest.BuildDirExit  (Path : PathStr);
BEGIN
END;

PROCEDURE TreeTest.ScanDirEnter  (Path : PathStr);
BEGIN
 Assign(Filez[GetLevel],Path+'odirind.txt');
 Rewrite(Filez[GetLevel]);

 {Write directory name to newly created file in this directory}

 Writeln(Filez[GetLevel]);
 Writeln(Filez[GetLevel],Path);
 Writeln(Filez[GetLevel]);

 IF GetLevel<>0 THEN    {If not rootdirectory of current CD, then also write to root}
  BEGIN
   Writeln(Filez[0]);
   Writeln(Filez[0],Path);
   Writeln(Filez[0]);
  END;
END;

PROCEDURE TreeTest.ScanDirExit  (Path : PathStr);
BEGIN
 Close(Filez[Getlevel]);
END;

FUNCTION TreeTest.BuildDetect    (Search:SearchRec;P:PathStr):BOOLEAN;

BEGIN
 BuildDetect:=TRUE;
END;

PROCEDURE TreeTest.FileFound (Path : PathStr;VAR Search : SearchRec;VAR UserPtr:POINTER);

BEGIN
 {Write directory name to index file in this directory}

 Writeln(Filez[GetLevel],Search.Name);

 IF GetLevel<>0 THEN    {If not in rootdirectory (of tree not of filesystem), then also write to root}
   Writeln(Filez[0],Search.Name);
END;

CONST
{$IFDEF Linux}
     Searchme='/root';
{$ELSE}
     Searchme='d:\pp';
{$ENDIF}

VAR TestObj  : TreeTest;

BEGIN
 { Write free heap to screen}

 writeln('Memory available before start :',memAvail);

 {Init class}

 TestObj:=TreeTest.TreeSearchInit;

 {Build tree in memory, starting with 'SearchMe', and add files depending
    on BuildDetect. Also BuildDirEnter is called when a directory is entered,
    and BuildTreeExit is called when leaving a directory (for a directory on
    a level closer to the root, not to a deeper nested directory) }

 TestObj.BuildTree(SearchMe);       { Scan directories, and create tree}

 {Write free memory to screen again}

 writeln('Memory free after building directorystructure:',memAvail);

 { Writes all names under d:\pp  to screen}

 TestObj.ScanTree;

 TestObj.TreeSearchFree;

 writeln('Memory free after disposing of object :',memAvail);
END.

{
27-02-99   - Creation, copied from DirTest.
           * After some small initial problems (init of OBJ, OBJPAS
              importing in ODirTree) it is running.

28-02-99   - Implemented the system I *expect* to need for simtel-ish
              indexes. One root index with all filenames in it, and in
              every subdirectory an index file with names of only the
              programs in that directory.
           # The only worry that I have with the current system is the number
              of files that can be open at the same time. 1 files.bbs,
              1 descript.ion, and an index PER level can easily get 30 files.
              10 levels are a lot, but not even really extraordinarily in
              things like TEX distributions etc. When outputting, this is
              no problem (a scantree per output type isn't that much slower),
              but when reading it might be.
           # Oops another drawback :-) Memory. 1 MB for 3000 files :-) }
