UNIT QuoLocal;
{ Belongs exclusively to QuoSetup. Not a shared unit.
                              (C) by Marco van de Voort 1996-98

  I divided the original source in two because I wanted to expand QuoSetup
  more. The expansion came through only done half, and development and using
  of the more generic routines of WinProc shortened the program even more

  This unit covers the array editting, while the mainprogram handles the
  mainmenu, the main-configuration record, and the loading and saving of the
  configurationfile.
  }

INTERFACE

Uses WinProc,ELib;


TYPE   IntRec           = Packed RECORD                     (* The record we're gonna edit *)
                           Tag       : String[40];
                           SelNumber : String[15];
                           Levels    : WORD;
                           Times     : ARRAY[0..10] OF WORD;
                           Costs     : ARRAY[0..11] OF WORD;
                           CostsWeek : ARRAY[0..11] OF WORD;
                           Special   : WORD;
                           END;
       LocalRec         = Packed RECORD
                           Descr     : String[25];
                           MainNum   : WORD;
                           LocalNums : ARRAY[0..11] OF WORD;
                           END;
       MainEditRec       = Packed RECORD
                            Mailer            : BYTE;
                            FDplace           : String[79];
                            OutputType        : BYTE;
                            CostCallLocal     : WORD;
                            LocalRound        : BYTE;
                            CostCallInter     : WORD;
                            InterRound        : BYTE;
                            AreaNumber        : WORD;
                            SecondOrTick      : BYTE;
                            HighTarifLow,
                            HighTarifHigh     : WORD;
                            TickexpensInter,
                            TickexpensLocal,
                            TickcheapInter,
                            TickcheapLocal    : WORD;
                            END;

      ArrType           = ARRAY[1..500] OF IntRec;
      LocalArrType      = ARRAY[1..150] OF LocalRec;
      TemplateType      = ARRAY[1..26] OF IntRec; (* Record Templates *)

{$I quodata.inc}

CONST ConfName='quo.cfg';
      Cyfer :CHARSET=['0'..'9'];
      AlfaBeta : CHARSET= [' '..'z'];

VAR    InterArr        : ^ArrType;
       LocalArr        : ^LocalArrType;
       TSLocal,
       TSMainRec,
       TSINT           : PBackGrType;
       TotalLocalRec   : LONGINT;
       TotalIntRec   : LONGINT;
       MainRec         : MainEditRec;
       Templ           : ^TemplateType;


PROCEDURE GetNumber(X,Y,Len1,Len2:LONGINT;VAR Erin:WORD);

PROCEDURE LocalEdit;
PROCEDURE IntEdit;
PROCEDURE MainEditProc;

PROCEDURE FdBackGr;

IMPLEMENTATION

Uses Crt,Strings,Ewindow,EPasStr;

{$I keys.inc}

PROCEDURE GetNumber(X,Y,Len1,Len2:LONGINT;VAR Erin:WORD);

VAR     DStr: String[30];
        Code  : WORD;
        Fl    : BOOLEAN;

BEGIN
 Code:=1;
 REPEAT
  Str(Erin,DStr);
  Fl:=InputStr(DStr,X+Len2,Y,Len1,TRUE,Cyfer);
  Val(DStr,Erin,Code);
 UNTIL Code=0;
END;


PROCEDURE FdBackGr;

VAR I : LONGINT;
    S : String[80];

BEGIN
 ClrScr;
 TextColor(LightGray);
 StrStr(S,#177,80);
 FOR I:= 3 TO 22 DO
  BEGIN
   GotoXY(1,I); Write(S);
  END;
 StrStr(S,'',80);
 TextColor(Blue);
 GotoXY(1,2);  Write(S);
 GotoXY(1,23); Write(S);
 GotoXY(1,24);
 TextColor(4); Write(' ':77);
END;

(* Array Edit procedures *)

PROCEDURE ArrEditBackGr;
BEGIN
 GotoXY(5,1);
 TextColor(Yellow);
 Write('Country Tag'); GotoXY(40,1); Write('Prefix');
END;

(* Table to convert ALT-x codes back to ordinal type *)
TYPE Card26Type= ARRAY[1..26] OF WORD;
CONST AltKeys:Card26Type=($1E00,$3000,$2E00,$2000,$1200,$2100,$2200,$2300,$1700,
                         $2400,$2500,$2600,$3200,$3100,$1800,$1900,$1000,$1300,
                         $1F00,$1400,$1600,$2F00,$1100,$2D00,$1500,$2C00);

PROCEDURE OtherArrKeys(Key :WORD;VAR CRec,NrRec : LONGINT);
{Special keys. ALT-A..Z are used to save templates for quick editting.
 Shift-A..Z pasted the templates.}

VAR A,B :LONGINT;


BEGIN
 CASE Key OF
  65..90 {A..Z} : Move(Templ^[Key-64],InterArr^[CRec],SIZEOF(IntRec));
  F1     :  IF NrRec >1 THEN
              (* ReSort( NrRec );*)
               CRec:=1;
  END;
 IF Key>255 (* Special Key  *) THEN
  BEGIN
  B:=0;
  FOR A:=1 TO 26 DO
   IF Key=AltKeys[A] THEN       (* Key= ALT-A..Z key? *)
    B:=A;                       (* Keep ordinal number*)
  IF B>0 THEN                   (* ALT A..Z found  yes -> run action *)
   Move(InterArr^[CRec],Templ^[B],SIZEOF(IntRec));
  END;
END;


PROCEDURE ArrEditDisplay(Nr,Y:LONGINT;Col:BYTE);

BEGIN
 SetAttrs(Col);
 GotoXY(5,Y+2);
 Write(' ':48);
 GotoXY(5,Y+2);
 Write(InterArr^[Nr].Tag);
 GotoXY(40,Y+2);
 Write(InterArr^[Nr].SelNumber);
END;

PROCEDURE DelRecPr(VAR Y,Nr:LONGINT);

BEGIN
 IF Nr=1 THEN
  Nr:=0
 ELSE
  IF (Nr>1) AND (Y=Nr) THEN
   BEGIN
    DEC(Nr);
    DEC(Y);
   END
  ELSE
   IF Nr>1 THEN
    BEGIN
     Move(InterArr^[Nr],InterArr^[Y],SIZEOF(IntRec));
     DEC(Nr);
    END;
END;

PROCEDURE InsRecPr(VAR Y,Nr:LONGINT);

BEGIN
 INC(Nr);
 FillChar(InterArr^[Nr],SIZEOF(IntRec),0);
END;

(* Edit Record procedures *)

PROCEDURE EditRBackGr;

BEGIN
 BuildScreenFromPtr(TSINT);
END ;

PROCEDURE EditF(Field,Rec :LONGINT);

VAR
    Fl : BOOLEAN;
    X,Y,
    Len1,Len2 : LONGINT;
    L : PChar;

BEGIN
 L:=GetStrPtr(TSINT,Field-1);
 X:=ORD(L[0])+1; Y:=ORD(L[1]); Len1:=ORD(L[2]); Len2:=StrLen(@L[4]);
 GotoXY(X+Len2,Y);
 CASE Field OF
  1  : Fl:=InputStr(InterArr^[Rec].Tag,X+Len2,Y,Len1,TRUE,AlfaBeta);
  2  : Fl:=InputStr(InterArr^[Rec].SelNumber,X+Len2,Y,Len1,TRUE,Cyfer);
  3..11 :  GetNumber(X,Y,Len1,Len2,InterArr^[Rec].Times[Field-3]);
  12..20 : GetNumber(X,Y,Len1,Len2,InterArr^[Rec].Costs[Field-12]);
  21..29 : GetNumber(X,Y,Len1,Len2,InterArr^[Rec].CostsWeek[Field-21]);
{  30     :}
 END;
END;

PROCEDURE DisplF(Y2: LONGINT;NrRec:LONGINT;Col:BYTE);

VAR
    X,Y,
    Len1,Len2 : LONGINT;
    L : PChar;

BEGIN
 L:=GetStrPtr(TSINT,Y2-1);
 X:=ORD(L[0])+1; Y:=ORD(L[1]); Len1:=ORD(L[2]); Len2:=StrLen(@L[4]);
 GotoXY(X+Len2,Y);
 SetAttrs(Col);
 Write(' ':Len1);
 GotoXY(X+Len2,Y);
 CASE Y2 OF
  1  : Write(InterArr^[NrRec].Tag);
  2  : Write(InterArr^[NrRec].SelNumber);
  3..11 :  Write(InterArr^[NrRec].Times[Y2-3]:-INTEGER(Len1));
  12..20 : Write(InterArr^[NrRec].Costs[Y2-12]:-INTEGER(Len1));
  21..29 : Write(InterArr^[NrRec].CostsWeek[Y2-21]:-INTEGER(Len1));
   30    : Write(InterArr^[NrRec].Special:-INTEGER(Len1));
   END;
END ;

(* MainProgram*)

CONST ArrEditArr : SelectEditRec =
                 (X1:5;Y1:5;X2:60;Y2:20;Frame:TRUE;Frametype:Style2;
                 ForeFrame:LightCyan;BackFrame:Black;BackCol:Black;
                 ForeCol:White;BackGrProc:@ArrEditBackGr;
                 DisplLine:@ArrEditDisplay;DelRecProc:@DelRecPr;
                 InsRecProc:@InsRecPr;ElseProc:@OtherArrKeys;Fields:30;
                 VisLines:12;MaxRec:HIGH(Arrtype));

      ArrEditR   : EditRec =
                 (EditField:@EditF;InitEdit:@EditRBackGr;DisplEdit:@DisplF;
                  X1:4;Y1:5;X2:70;Y2:20;Frame:TRUE;FrameType:Style2;
                  ForeFrame:LightCyan;BackFrame:Black;BackCol:Black;
                  ForeCol:Yellow);


PROCEDURE LocalArrEditBackGr;
BEGIN
 GotoXY(5,1);
 TextColor(Yellow);
 Write('Region('#39's main city)'); GotoXY(40,1); Write('Prefix');
END;

PROCEDURE LocalOtherArrKeys(Key :WORD;VAR CRec,NrRec : LONGINT);

BEGIN
 IF Key=F1 THEN
  BEGIN
   IF NrRec >1 THEN
    BEGIN
     (* ReSort( NrRec );*)
     CRec:=1;
    END;
  END;
END;


PROCEDURE LocalArrEditDisplay(Nr,Y:LONGINT;Col:BYTE);

BEGIN
 SetAttrs(Col);
 GotoXY(5,Y+2);
 Write(' ':48);
 GotoXY(5,Y+2);
 Write(LocalArr^[Nr].Descr);
 GotoXY(40,Y+2);
 Write(LocalArr^[Nr].MainNum:-5);
END;

PROCEDURE LocalDelRecPr(VAR Y,Nr:LONGINT);

BEGIN
 IF Nr=1 THEN
  Nr:=0
 ELSE
  IF (Nr>1) AND (Y=Nr) THEN
   BEGIN
  DEC(Nr);
  DEC(Y);
   END
  ELSE
   IF Nr>1 THEN
    BEGIN
     Move(LocalArr^[Nr],LocalArr^[Y],SIZEOF(LocalRec));
     DEC(Nr);
    END;

END;

PROCEDURE LocalInsRecPr(VAR Y,Nr:LONGINT);

BEGIN
 INC(Nr);
 FillChar(LocalArr^[Nr],SIZEOF(LocalRec),0);
END ;

(* Edit Record procedures *)

PROCEDURE LocalEditRBackGr;

BEGIN
 BuildScreenFromPtr(TSLocal);
END;

PROCEDURE LocalEditF(Field,Rec :LONGINT);

VAR
    Fl        : BOOLEAN;
    X,Y,
    Len1,Len2 : LONGINT;
    L         : PChar;

BEGIN
 L:=GetStrPtr(TSLocal,Field-1);
 X:=ORD(L[0])+1; Y:=ORD(L[1]); Len1:=ORD(L[2]); Len2:=StrLen(@L[4]);
 GotoXY(X+Len2,Y);
 CASE Field OF
  1  : Fl:=InputStr(LocalArr^[Rec].Descr,X+Len2,Y,Len1,TRUE,AlfaBeta);
  2  : GetNumber(X,Y,Len1,Len2,LocalArr^[Rec].MainNum);
  3..14: GetNumber(X,Y,Len1,Len2,LocalArr^[Rec].LocalNums[Field-3]);
 END;
END;

PROCEDURE LocalDisplF(Y2: LONGINT;NrRec:LONGINT;Col:BYTE);

VAR
    X,Y,
    Len1,Len2 : LONGINT;
    L : PChar;

BEGIN
 L:=GetStrPtr(TSLocal,Y2-1);
 X:=ORD(L[0])+1; Y:=ORD(L[1]); Len1:=ORD(L[2]); Len2:=StrLen(@L[4]);
 GotoXY(X+Len2,Y);
 SetAttrs(Col);
 Write(' ':Len1);
 GotoXY(X+Len2,Y);
 CASE Y2 OF
  1  : Write(LocalArr^[NrRec].Descr);
  2  : Write(LocalArr^[NrRec].MainNum:-5);
  3..14 :  Write(LocalArr^[NrRec].LocalNums[Y2-3]:-INTEGER(Len1));
  END;
END;

CONST EditArr: SelectEditRec=(X1:5;Y1:5;X2:60;Y2:20;Frame:TRUE;Frametype:Style2;
              ForeFrame:LightCyan;BackFrame:Black;BackCol:Black;ForeCol:White;
              BackGrProc:@LocalArrEditBackGr;DisplLine:@LocalArrEditDisplay;
              DelRecProc:@LocalDelRecPr;InsRecProc:@LocalInsRecPr;ElseProc:@LocalOtherArrKeys;Fields:14;VisLines:12;MaxRec:HIGH(LocalArrType));

      EditR:EditRec=(EditField:@LocalEditF;InitEdit:@LocalEditRBackGr;DisplEdit:@LocalDisplF;
                      X1:4;Y1:5;X2:70;Y2:20;Frame:TRUE;Frametype:Style2;ForeFrame:LightCyan;BackFrame:Black;BackCol:Black;ForeCol:Yellow);

PROCEDURE LocalEdit;

VAR OO            : ^SelectEditRec;
    EE            : ^EditRec;

BEGIN
  NEW(OO); NEW(EE);
  OO^:=EditArr; EE^:=EditR;
  EditArray(OO^,EE^,TotalLocalRec);
  DISPOSE(OO); DISPOSE(EE);
END;

(* --------------------- Main Information Record----------------------- *)

PROCEDURE MainEditRBackGr;

BEGIN
 BuildScreenFromPtr(TSMainRec);
END;

CONST MailerToggle=CHR(4)+'Intermail@Xenia@FrontDoor@MainDoor';
      OutputToggle=CHR(3)+'ANSI@LOWASCII@HIGHASCII';
      SecTikToggle=CHR(2)+'Seconds@Ticks';

PROCEDURE MainEditF(Field,Rec :LONGINT);

VAR
    Fl        : BOOLEAN;
    X,Y,
    Len1,Len2 : LONGINT;
    L         : PChar;

BEGIN
 L:=GetStrPtr(TSMainRec,Field-1);
 X:=ORD(L[0])+1; Y:=ORD(L[1]); Len1:=ORD(L[2]); Len2:=StrLen(@L[4])+1;
 GotoXY(X+Len2,Y);
 CASE Field OF
  1  : Toggler(MainRec.Mailer,MailerToggle,TRUE);
  2  : Fl:=InputStr(MainRec.FDplace,X+Len2,Y,Len1,TRUE,AlfaBeta);
  3  : Toggler(MainRec.OutputType,OutputToggle,TRUE);
  4  : GetNumber(X,Y,Len1,Len2,MainRec.CostCallLocal);
  5  : Toggler(MainRec.LocalRound,YesNo,TRUE);
  6  : GetNumber(X,Y,Len1,Len2,MainRec.CostCallInter);
  7  : Toggler(MainRec.InterRound,YesNo,TRUE);
  8  : GetNumber(X,Y,Len1,Len2,MainRec.AreaNumber);
  9  : Toggler(MainRec.SecondOrTick,SecTikToggle,TRUE);
  10 : GetNumber(X,Y,Len1,Len2,MainRec.HighTarifLow);
  11 : GetNumber(X,Y,Len1,Len2,MainRec.HighTarifHigh);
  12 : GetNumber(X,Y,Len1,Len2,MainRec.TickexpensInter);
  13 : GetNumber(X,Y,Len1,Len2,MainRec.TickexpensLocal);
  14 : GetNumber(X,Y,Len1,Len2,MainRec.TickcheapInter);
  15 : GetNumber(X,Y,Len1,Len2,MainRec.TickcheapLocal);

 END;
END;

PROCEDURE MainDisplF(Y2: LONGINT;NrRec:LONGINT;Col:BYTE);

VAR
    X,Y,
    Len1,Len2           : LONGINT;
    L                   : PChar;

BEGIN
 L:=GetStrPtr(TSMainRec,Y2-1);
 X:=ORD(L[0])+1; Y:=ORD(L[1]); Len1:=ORD(L[2]); Len2:=StrLen(@L[4])+1;
 GotoXY(X+Len2,Y);
 SetAttrs(Col);
 Write(' ':Len1);
 GotoXY(X+Len2,Y);
 CASE Y2 OF
  1  : Toggler(MainRec.Mailer,MailerToggle,FALSE);
  2  : Write(MainRec.FDplace);
  3  : Toggler(MainRec.OutputType,OutputToggle,FALSE);
  4  : Write(MainRec.CostCallLocal:-INTEGER(Len1));
  5  : Toggler(MainRec.LocalRound,YesNo,FALSE);
  6  : Write(MainRec.CostCallInter:-INTEGER(Len1));
  7  : Toggler(MainRec.InterRound,YesNo,FALSE);
  8  : Write(MainRec.AreaNumber:-INTEGER(Len1));
  9  : Toggler(MainRec.SecondOrTick,SecTikToggle,FALSE);
  10 : Write(MainRec.HighTarifLow:-INTEGER(Len1));
  11 : Write(MainRec.HighTarifHigh:-INTEGER(Len1));
  12 : Write(MainRec.TickexpensInter:-INTEGER(Len1));
  13 : Write(MainRec.TickexpensLocal:-INTEGER(Len1));
  14 : Write(MainRec.TickcheapInter:-INTEGER(Len1));
  15 : Write(MainRec.TickcheapLocal:-INTEGER(Len1));
  END;
END ;

CONST

   MainEditR:EditRec=(EditField:@MainEditF;InitEdit:@MainEditRBackGr;DisplEdit:@MainDisplF;
                    X1:4;Y1:5;X2:70;Y2:22;Frame:TRUE;FrameType:Style2;ForeFrame:LightCyan;BackFrame:Black;BackCol:Black;ForeCol:Yellow);

PROCEDURE MainEditProc;


VAR
    EE            : ^EditRec;

BEGIN
  NEW(EE);
  EE^:=MainEditR;
  EditRecord(EE^,15,1);
  DISPOSE(EE);
END;

PROCEDURE IntEdit;


VAR
    EE            : ^EditRec;
    OO            : ^SelectEditRec;

BEGIN
  NEW (OO); NEW(EE); (* records can be editted, copy CONST contents*)
  OO^:=ArrEditArr; EE^:=ArrEditR;
  EditArray(OO^,EE^,TotalIntRec);
  DISPOSE (OO); DISPOSE(EE);
END;

END.
