PROGRAM QuoSetup;

{ Setup program for some logfile scanner (logfile of Frontdoor, a BBS-Mailer).
  Now demo for units EWindow and WinProc
                              (C) by Marco van de Voort 1996-98

  I used to maintain an util, and for the next major version, I wanted to
  create a setup-program in the often used FrontDoor style (a standard in the
  BBS world). However the project died quickly before the setup-program was
  ready. I rougly finished the program, and now I use the sources to
  demonstrate unit WinProc (with very simple dialogue routines).

  QuoSetup reads a file Quo.cfg, which then can be changed using the keys,
  and is saved again afterwards.

  The FPC version isn't free from bugs yet, but as far as I know those are only
  cosmetic, and small annoyances when editting. (originate from different
  convention for GotoXY, Topleft M2: (0,0), FPC: (1,1), and the alignment factor
  of write can be negative under M2. That's why the numbers aren't aligned
  properly)

  QUOSETUP is not really shocking, but it proves that there is something
  between a simple Crt GotoXY method and TurboVision, for just over 1000 lines.

  }

Uses QuoLocal,  { Dedictated unit to QuoSetup}
     WinProc,   { General dialogues}
     Crt,       { Text IO}
     EpasStr,   { Extra Pascal-string routines}
     Strings,   { PChar handling. I use the StrLen function for some things}
     EWindow,   { Textwindowing, based on Crt}
     EFIO,      { Misc file routines}
     Elib;      { Misc routines, I believe I only imported it for CHARSET}


PROCEDURE SaveArr;

VAR F: File;
    A : LONGINT;

BEGIN
 Assign(F,ConfName);
 Rewrite(F,1);
 BlockWrite(F,TotalIntRec,2);
 BlockWrite(F,TotalLocalRec,2);
 A:=SIZEOF(MainRec);
 BlockWrite(F,A,2);
 BlockWrite(F,MainRec,SIZEOF(MainRec));

(* This code is only used to convert the quo.cfg to a new format when
    new fields are added.
 FOR A:= 1 TO TotalIntRec DO
  FIO.WrBin(F,InterArr^[A],SIZE(IntRec));
  END; *)
 BlockWrite(F,InterArr^[1],SIZEOF(IntRec)*TotalIntRec);
 BlockWrite(F,LocalArr^[1],SIZEOF(LocalRec)*TotalLocalRec);
 Close(F);
END;

PROCEDURE ASCIITOTP(VAR L : String;TotLen:LONGINT);

VAR Tmp:LONGINT;
    C  :LONGINT;

BEGIN
 L[TotLen-1]:=CHR(0);
 Tmp:=StrLen(@L[0]);
 IF Tmp>=TotLen THEN
  Tmp:=Totlen-1;
 FOR C:=Tmp Downto 1 DO
  L[C]:=L[C-1];
 L[0]:=CHR(Tmp);
END;

PROCEDURE LoadArr;

VAR F     : File;
    A     : LONGINT;
    Fl    : BOOLEAN;

BEGIN
 Assign(F,Confname);
 Reset(F,1);
 TotalIntRec:=0; TotalLocalRec:=0;
 BlockRead(F,TotalIntRec,2); {Convert to 32-bit}
 BlockRead(F,TotalLocalRec,2); {Convert to 32-bit}
// Writeln(TotalintRec,' ',Totallocalrec); HALT;

 BlockRead(F,A,2);
 BlockRead(F,MainRec,SIZEOF(MainRec));
{ Fl:=FALSE;
 IF MainRec.FdPlace[1]='D' THEN                {Used to convert from M2
                                                   version}}
  Fl:=TRUE;
 IF NOT Fl Then
  ASCIITOTP(MainRec.FdPlace,80);
 BlockRead(F,InterArr^[1],SIZEOF(IntRec)*TotalIntRec);
 BlockRead(F,LocalArr^[1],SIZEOF(LocalRec)*TotalLocalRec);
 IF NOT Fl THEN
  BEGIN
  FOR A:=1 TO TotalIntRec DO
   BEGIN
    ASCIITOTP(InterArr^[A].Tag,41);
    ASCIITOTP(InterArr^[A].SelNumber,16);
   END;
  FOR A:=1 TO TotalLocalRec DO
   BEGIN
    ASCIITOTP(LocalArr^[A].Descr,26);
   END;
  END;
 Close(F);
END;

PROCEDURE MenuLine(A,B:LONGINT;Col:BYTE);

BEGIN
 SetAttrs(Col);
 GotoXY(4,B+3);
 CASE A OF
  1 : Write(' General Settings ');
  2 : Write(' Costs information within your country');
  3 : Write(' Costs information abroard and for special numbers ');
 END;
END;

PROCEDURE SelectMenu;

CONST WD:WinDef=(X1:10;Y1:4;X2:70;Y2:11;ForeGround:LightGray;BackGround:Black;
                 FrameOn:TRUE;FrameDef:Style2;FrameFore:LightCyan;FrameBack:Black);

VAR CRec,First,
    Key       : LONGINT;
    Win       : WinType;

BEGIN
 {$IFNDEF Linux}
  CursorOff;
 {$ENDIF}
 Win:=WinOpen(WD);
 Use(Win);
 GotoXY    (20,1);
 TextColor (White);
 Write     (' Main menu ');
 TextColor(LightGray);
 First:=1;
 CRec:=First;
 REPEAT
      NormalColor  := ORD(LightGray)+ORD(Black)*16;
      Key := Selector(@MenuLine, 3, 3, First, CRec);
      CASE Key OF
        13      :  BEGIN
                    CASE CRec OF
                      1 : BEGIN
                            NormalColor  := ORD(White)+ORD(Black)*16;
                            MainEditProc;
                           END;
                      2 : LocalEdit;
                      3 : IntEdit;
                     END;
                     Use(Win);
                  END;
        END;
        UNTIL Key=ESC;
 WinClose(Win);
 {$IFNDEF Linux}
 CursorOn;
 {$ENDIF}
END;


BEGIN
  NEW(InterArr); NEW(Templ); NEW(LocalArr);
  FdBackGr;
  IF FileExists(ConfName) THEN
   BEGIN
    Writeln;
    Write(' Loaded ',ConfName);
    LoadArr;
   END
  ELSE
   begin
   Fillchar(InterArr^[1],SIZEOF(InterArr),CHR(0));
   InterArr^[1].Tag:='Germany';
   InterArr^[1].SelNumber:='31';
   InterArr^[1].Times[0]:=600;    InterArr^[1].Times[1]:=1200;
   InterArr^[1].Times[2]:=1800;   InterArr^[1].Times[3]:=2200;
   InterArr^[1].Times[4]:=2300;
   TotalIntRec:=1;
   END;
  TSINT:=  InitBigStr(@BackGrndInterTxt,SIZEOF(BackGrndInterTxt));
  TSLocal:=InitBigStr(@BackGrndLocalTxt,SIZEOF(BackGrndLocalTxt));
  TSMainRec:=InitBigStr(@MainEditBackGrTxt,SIZEOF(MainEditBackGrTxt));

  SelectMenu;
  SaveArr;
END.
