program simcrypt;
{ Simple encrytion demo part of the XtdLib/FPC package.
                                (C) Marco van de Voort 1998

The simplest form of encryption. XORring. Instead of using a simple byte key,
  a simple algoritm with length(password), and each letter of the pasword is
  used to change the key for each consecutive byte.

Not meant for heavy security. I'm not a nummerics expert, but I think something
like this can be broken easily. Even by brute force.

I originally used it to camouflage .ZIP files in installation packages, not
to encrypt docs about the H-bomb.

Crypting twice with the same password recreates the old file}

Uses EFIO;

CONST Usagestr='Usage: simcrypt [filename1] <filename2> "password"';

Procedure Usage;

BEGIN
 Writeln(UsageStr);
 HALT;
END;

VAR F1,F2 : File;
    Buf   : ARRAY[0..4095] OF BYTE;
    InBuf : LONGINT;
    S,Name1,Name2 : String;
    A     : LONGINT;
    Key   : BYTE;
    C     : BYTE;
    B     : LONGINT;
    Len   : LONGINT;

PROCEDURE EncryptIt; {The actual encryption, crypts "inbuf" chars in "buf"}

BEGIN
  FOR A:=0 TO InBuf-1 DO                     {Loop}
   BEGIN
    Buf[A]:=Buf[A] XOR Key;                  {Char = char XOR key :-)}
    Key:=Key XOR ORD(S[1+(B MOD Len)]);      {xor key with password data}
    INC(B);                                  {Count total chars}
   END;
END;

BEGIN
 A:=ParamCount;
 IF A<2 THEN
  Usage;
 Name1:=ParamStr(1);
 IF A=3 THEN
  Name2:=ParamStr(2)
 ELSE
  BEGIN
   Name2:=Name1;
   ChangeExtension(Name2,'cpt');
   IF Name1=Name2 THEN
    ChangeExtension(Name2,'cp2');
  END;
 IF NOT FileExists(Name1) THEN   {Also EFIO}
  BEGIN
   Writeln ('File doesnt exist');
   HALT
  END;
 S:=ParamStr(A);
 Assign(F1,Name1); Writeln('Reading from ',Name1);
 Reset(F1,1);
 Assign(F2,Name2); Writeln('Writing to ',Name2);
 Rewrite(F2,1);
 B:=0;                             {Counter which counts total bytes, also used
                                     in encryption}
 Key:=ORD(S[1]);                   {Initial key is first char in password}
 Len:=Length(S);                   {Used often (in algoritm) so keep in local regs}
 REPEAT
  BlockRead(F1,Buf,4096,InBuf);
  IF InBuf<>0 THEN
   BEGIN
    EncryptIt;
    BlockWrite(F2,Buf,InBuf);
   END;
 UNTIL InBuf=0;
 Close(F1);
 Close(F2);
END.
