program sorttest;

TYPE
  LCompareProc = FUNCTION(Par1:CARDINAL; Par2:CARDINAL) : BOOLEAN;
  LSwapProc    = PROCEDURE(Par1:CARDINAL; Par2:CARDINAL);

PROCEDURE LHSort(N: CARDINAL; Less: LCompareProc; Swap: LSwapProc);
VAR
  i,j,k : CARDINAL;
  Fl    : BOOLEAN;
BEGIN
  IF N > 1 THEN
   BEGIN
    i := N DIV 2;
    REPEAT
      j := i;
      REPEAT (* Note that total repeats <= N/4 * 1 + N/8 * 2 + N/16 * 3 + .... *)
        k := j * 2;
        IF k > N THEN
         EXIT;
        IF (k < N) AND Less(k,k+1) THEN
         INC(k);
        Fl:=Less(j,k);
        IF Fl THEN
         BEGIN
          Swap(j,k);
          j := k;
         END
      UNTIL NOT Fl;
      DEC(i);
    UNTIL i = 0;

    i := N;
    REPEAT
      j := 1;
      Swap(j,i);
      DEC(i);
      REPEAT
        k := j * 2;
        Fl:=FALSE;
        IF k <= i THEN
         BEGIN
          Fl:=TRUE;
          IF ( k < i ) AND Less(k,k+1) THEN
           INC(k);
          Swap(j,k);
          j := k;
         END;
      UNTIL NOT Fl;
      REPEAT
        k := j DIV 2;
        Fl:=(k > 0) AND Less(k,j);
        IF Fl THEN
         BEGIN
          Swap(j,k);
          j := k;
         END;
     UNTIL NOT Fl;
    UNTIL i = 0;
  END;
END;


PROCEDURE LQSort(N: CARDINAL; Less: LCompareProc; Swap: LSwapProc);

  PROCEDURE Sort(l,r: CARDINAL);
  VAR
    i,j:CARDINAL;
  BEGIN
    WHILE r > l DO
     BEGIN
      i := l+1;
      j := r;
      WHILE i <= j DO
       BEGIN
        WHILE (i <= j) AND NOT Less(l,i) DO INC(i);
        WHILE (i <= j) AND Less(l,j) DO DEC(j);
        IF i <= j THEN
         BEGIN
          Swap(i,j);
          INC(i);
          DEC(j)
         END;
      END;
      IF j <> l THEN
       Swap(j,l);
      IF (j+j) > (r+l) THEN (* small one recursively *)
       BEGIN
        Sort(j+1,r);
        r := j-1;
       END
      ELSE
       BEGIN
        Sort(l,j-1);
        l := j+1;
      END;
    END;
  END;

BEGIN
  Sort(1,N);
END

BEGIN
END.
