PROGRAM WindTest;
{ Demo of some of the fundamental routines of module window.
  Temporary version, until PullDown and WinProcs are ported, and
    I can make a more sophisticated version.

   This is a demo of the XTDLIB/FPK package
   COPYRIGHT (C) 1993..1998 by Marco van de Voort,  All Rights Reserved
   Free for non-commercial use. See license.txt.
   (www.stack.nl/~marcov/xtdlib.htm)
   Free for non-commercial use.

   Run WindTest first in animation mode,
   and after that single step, holding the spacebar, to get an idea of the
     speed.
   }


Uses Crt,EWindow;

{$I syseq.inc}            {XtdFPK's configuration file, used to check
                            if we are running under linux, and for
                            BP compability}

{Copied from ELib, so I don't have to add ELib to development packages}
FUNCTION GetKey:WORD;

VAR InKey : WORD;

BEGIN
 InKey:=ORD(ReadKey);
 IF InKey=0 THEN InKey:=ORD(ReadKey) SHL 8;
 GetKey:=InKey;
END;


VAR Delayit : BOOLEAN;      {Use delays between steps(TRUE) or wait for a key}

PROCEDURE DoKey;
{Waits for key, or pauses with delay depending on Delayit.
  Pressing enter while delayit=false will turn delayit on,
  any key        whule delayit=true  will turn delayit off.}
 
VAR A : WORD;

BEGIN
 IF Delayit THEN 
  BEGIN
   Delay(750);
   IF KeyPressed THEN
    BEGIN
     ReadKey;
     Delayit:=FALSE;
    END;
   END
 ELSE
  BEGIN 
   A:=GetKey;
   IF A=13 THEN
    Delayit:=TRUE;
  END;
 IF A=65 THEN
  HALT;
END;

(* Window definitions, see comments declaration WinDef in window.pas.
     The Y2 coordinates are changed by SpecWinOpen if a bigger screen
      (like 80x50) is detected. *)

CONST WD1:WinDef=(X1:10;Y1:13;X2:50;Y2:25;Foreground:White;Background:Black;Frameon:TRUE;FrameDef:Style1;
                FrameFore:Yellow;FrameBack:Blue);

      WD2:WinDef=(X1:40;Y1:12;X2:70;Y2:18;Foreground:Magenta;Background:Green;Frameon:TRUE;FrameDef:Style2;
                FrameFore:White;FrameBack:Green);

      WD3:WinDef=(X1:30;Y1:15;X2:70;Y2:22;Foreground:LightBlue;Background:Blue;Frameon:TRUE;FrameDef:Style3;
               FrameFore:Yellow;FrameBack:Magenta);

      WD5:WinDef=(X1:12;Y1:14;X2:68;Y2:23;Foreground:LightGreen;Background:brown;Frameon:FALSE;FrameDef:Style4;
                FrameFore:Yellow;FrameBack:Magenta);

      {The number of windows that is created during the last phase of the
        program, when a number of random windows is first opened}
      RanWinNr = 50; {You can make this a lot higher, but if you have a lot
                        of windows, make sure you use singlestep mode.
                        (or the demo will take as much seconds as the number
                         of windows you have) }

VAR A,B         : INTEGER;
    Win,Win2,
    Win3,Win4,
    Win5        : WinType;
    Fl	        : BOOLEAN;
    WD          : WinDef;
    RanWin      : ARRAY[0..RanWinNr] OF WinType;
    LotOfLines  : BOOLEAN;
    S           : String;

PROCEDURE SwitchWindows(Win4_5Too:BOOLEAN);
{Switches sequentially to window 1..3 (Win4_5Too:=FALSE), or 1..5 (TRUE)}

BEGIN
  Use(Win);
  TextColor(LightCyan);
  writeln;
  Write('Switching to Win1');
  DoKey;
  Use(Win2);
  TextColor(LightGreen);          {Textcolor is independant for each window}
  writeln;
  Write('Switching to Win2');
  DoKey;
  Use(Win3);
  writeln;
  TextColor(LightMagenta);
  Write('Switching to Win3');
  DoKey;
  IF Win4_5TOO THEN
   BEGIN
    Use(Win4);
    TextColor(LightGreen);
    writeln;
    Write('Switching to Win4');
    DoKey;
    Use(Win5);
    writeln;
    TextColor(LightMagenta);
    Write('Switching to Win5');
    DoKey;
   END;
END;

FUNCTION SpecWinOpen(WDIn:WinDef):WinType;
{Wrapper round WinOpen. Enlarges windows below line 25 if a 80x43 or 80x50
    is detected}

BEGIN
 IF LotOfLines THEN
  WDIn.Y2:=RANDOM(20)+25;
 IF WDIn.Y2>Height THEN
  WDIn.Y2:=Height;
 SpecWinOpen:=WinOpen(WDIn);
END;

BEGIN
 DelayIt:=True;
 RANDOMIZE;
 IF Height>25 THEN
  LotOfLines:=TRUE
 ELSE
  LotOfLines:=FALSE;

  {Open 3 windows, pause after each step}

 Win:=SpecWinOpen(WD1);

 SetTitle(Win,'Window 1');
 TextColor(LightGray);
 WrapWriteLn('This program demonstrates unit EWindow by opening and manipulating some windows');
  
 Writeln; 
 WrapWriteLn('Do you want to');
 TextColor(Yellow); Write('A'); TextColor(LightGray);
 WrapWriteLn('nimate the demo (delay between actions) or');
 TextColor(Yellow); Write('S'); TextColor(LightGray);
 WrapWriteln('ingle step it (Wait for keystroke)?');
 
 Fl:=FALSE;
 WHILE NOT Fl DO
  IF KeyPressed THEN
   BEGIN
    A:=GetKey;
    IF (A=65) OR (A=97) THEN
     BEGIN
      Fl:=TRUE;
      Delayit:=TRUE;
     END;
    IF (A=ORD('S')) OR (A=ORD('s')) THEN
     BEGIN
      Fl:=TRUE;
      Delayit:=FALSE;
     END; 
   END;

{$IFNDEF Linux}
  TextColor(LightCyan);
  WrapWriteln('Turning of the cursor for this window');
  DoKey;
  {CursorOff;}
{$ENDIF}

  Win2:=SpecWinOpen(WD2);
  SetTitle(Win2,'Window 2');
  Write('This is also text');
  DoKey;

  Win3:=SpecWinOpen(WD3);
  SetTitle(Win3,'Window 3');
  Write('What a surprise, again text');
  TextColor(Green);
  TextBackGround(Blue);
  DoKey;

  {Now switch from window to window, write something in each window}

  SwitchWindows(False);

  {Hide window 2, clear window 3, Unhide window 2 and write text in it}
  Writeln;
  TextColor(LightGreen);
  Writeln('Hiding Window 2');
  Hide(Win2);
  DoKey;
  TextColor(LightMagenta);
  Writeln('Clearing Window 3');
  DoKey;
  Clear(Win3);
  Unhide(Win2);
  Use(Win2);
  TextColor(LightCyan);
  Writeln;
  WrapWrite('Win2 unhidden, and activated. Now I' +#39+'m gonna resize and reposition Window1');
  DoKey;

  {Moving the Windows around}

  Change(Win,10,3,20,8);                          {Move AND resize.}
  DoKey;

  Use(Win3);
  Writeln;
  TextColor(Cyan);
  Writeln('Moving window 3 around a bit');
  Writeln('From (1,1) to (20,10)');
  DoKey;
  FOR A:=1 TO 10 DO
   BEGIN
    Delay(20);
    WinMove(Win3,2*A,A);                          {Faster than Change}
   END;

  {Cloning Win3}
  TextColor(White);
  Writeln(' I',#39,'m gonna clone Window 3');
  TextColor(Yellow);
  DoKey;
  Win4:=WinClone(Win3);

  WrapWriteln('You don'+#39+'t see anything? That'+#39+'s right.'+
             ' The window is hidden, and under this Window');
  DoKey;
  TextColor(Yellow);
  Write(' moving');                       WinMove(Win4,5,5);
  Delay(250);
  TextColor(LightGreen);
  Write(' unhiding');                     Unhide(Win4);
  Delay(250);
  TextColor(White);
  Write(' Switching to Window 4');
  Delay(250);                             Use(Win4);

  SetTitle(Win4,'Window 4');
  TextColor(LightCyan);
  Write('Here I am!!!');
  DoKey;

  Win5:=SpecWinOpen(WD5);

  SetTitle(Win5,'Window 5'); {Win5=Non frame window, does nothing}

   {Two writes, 255 character string limitation}
  WrapWrite('Creating Window 5 to make the screen look a bit crowded, and to demonstrate a frameless'+
            ' window for a change. Frameless windows are no different from frame windows, except that the'+
            ' entire surface can be written. This text is written by the'+
            ' wrapwrite ');
  WrapWrite('procedure. Since EWindow doesn'#39't handle normal writes itself (Crt does), I can'#39't'+
            ' implement wrap as a window-property, like the way it'#39's done under Modula2.');

  DoKey;
  SwitchWindows(TRUE);

{Close all windows, but switch to that window first, and write a message in it}
 
  Use(Win);
  TextColor(Green);
  TextBackGround(Blue);
  Writeln;
  Write(' Closing this window (Win1)');
  DoKey;
  WinClose(Win);

  Use(Win2);
  Writeln;
  Write(' Closing this window (Win2)');
  DoKey;
  WinClose(Win2);
  Use(Win3);
  TextColor(LightGreen);
  TextBackGround(Blue);
  Writeln;
  Write(' Closing this window (Win3)');
  DoKey;
  WinClose(Win3);
  Use(Win4);
  TextColor(LightCyan);
  TextBackGround(Blue);
  Writeln;
  Write(' Closing this window (Win4)');
  DoKey;
  WinClose(Win4);
  Use(Win5);
  TextColor(LightCyan);
  TextBackGround(Blue);
  Writeln;
  Write(' Closing this window (Win5)');
  Dokey;
  WinClose(Win5);
  DoKey;

  FOR A:= 0 TO RanWinNr DO
   BEGIN
    B:=A MOD 31;
    WD.X1:=RANDOM(10+B)+1;
    WD.X2:=20+RANDOM(35+3*B);
    IF (WD.X2-WD.X1)<5 THEN WD.X2:=WD.X1+20+RANDOM(35+3*B);
    IF WD.X2>Width THEN WD.X2:=Width;
    WD.Y1:=RANDOM(5+B)+1;
    IF LotOfLines THEN
     WD.Y2:=RANDOM(1+B*2)+20
    ELSE
     WD.Y2:=RANDOM(10+B*2)+1;
    IF (WD.Y2-WD.Y1)<5 THEN WD.Y2:=WD.Y1+10+RANDOM(5);
    IF WD.Y2>Height THEN WD.Y2:=Height;
    IF WD.Y1>=Height THEN WD.Y1:=Height-5;

    IF (WD.Y2=Height) AND (WD.X2=Width) THEN
     DEC(WD.X2);                            {Avoid scrolling}
    WD.Foreground:=RANDOM(15);
    WD.BackGround:=(RANDOM(15));
    WD.FrameFore:=RANDOM(15);
    WD.FrameBack:=(RANDOM(15));
    WD.FrameOn:=(RANDOM(2)=1);
    CASE RANDOM(4) OF
     1 : WD.FrameDef:=Style1;
     2 : WD.FrameDef:=Style2;
     3 : WD.FrameDef:=Style3;
     4 : WD.FrameDef:=Style4;
    END;
    RanWin[A]:=WinOpen(WD);
    b:=A DIV 10;
    S:='Window ' + CHR((B div 10)+48)+ CHR((B MOD 10)+48)+ CHR((A MOD 10)+48);
    SetTitle(RanWin[A],@S[1]);
    Writeln(S);
    Writeln;
    TextColor(Random(15)); TextBackground(Random(15));
    Write('Some other text');
    IF DelayIt THEN
     Delay(500);
   END;
  FOR A:= 0 TO RanWinNr DO
   BEGIN
    Use(RanWin[A]);
    Writeln;
    TextColor(Random(15)); TextBackground(Random(15));
    Write('Closing this window');
    IF DelayIt THEN
     Delay(500);
    WinClose(RanWin[A]);
   END;
  IF NOT Delayit THEN
   BEGIN
    {$IFDEF GO32V2}
    Writeln(' Press a key to return to dos');
    {$ENDIF}
    {$IFDEF Linux}
    Writeln(' Press a key to return to Linux');
    {$ENDIF}
    DoKey;
   END;
END.
