{ Marco van de Voort. Donated to the FPC project.

This include file won't compile.
 It's more a barrel of routines that could be used as an alternative for some
 routines in astrings.pp

Also there are three POS procedures. One normal, one for one character only
(overloaded just as for ordinary strings) and the one character only procedure
in assembler.

Most routines (Except the Pos ones, NewAnsiString and length) are untested,
since I haven't found out how to test easily. The routines are more to
demonstrate how easy and straight forward astrings assembler procedures are,
contrary to the 9 typecasts-with-pointerarithmic of the pascal versions.
After testing however, the routines are usable, except that the call-labels have
to be adapted.
}

FUNCTION NewAnsiString(Len : LONGINT):AnsiString; ASSEMBLER;

VAR P : POINTER;

ASM
                   mov    8(%ebp),%eax            // maxlength
                   addl   $13,%eax                // add 3 longint's + one #0
                   pushl  %eax
                   leal   -4(%ebp),%eax
                   pushl  %eax
                   call  _SYSTEM$$_GETMEM$POINTER$LONGINT
                   movl    8(%ebp),%eax
                   movl   -4(%ebp),%edi
                   stosl                          // Store allocated space
                   xor    %eax,%eax

                   stosl                          // real length=0
                   incl   %eax
                   stosl                          // reference=1, just created.
                   decl   %eax
                   movb   %al,(%edi)              // store zero btyes
                   mov    %edi,%eax               // returnvalue.
end ['eax','ebx','ecx','edx','esi','edi']; { so big because of what does GetMem do!}

{ DisposeAnsistring has no reference check!}
PROCEDURE DisposeAnsiString(Var S : AnsiString); ASSEMBLER;

ASM
                   movl    8(%ebp),%eax
                   movl    (%eax),%eax
                   test    %eax,%eax
                   je      .LDisposeEnd
                   subl    $12,%eax
                   movl    (%eax),%ebx
                   addl    $13,%ebx
                   pushl   %ebx
                   movl    8(%ebp),%eax
                   pushl   %eax
                   call    _SYSTEM$$_FREEMEM$POINTER$LONGINT
                   movl    8(%ebp),%ebx
                   xor     %eax,%eax
                   movl    %eax,(%ebx)
.LDisposeEnd:
END ['eax','ebx','ecx','edx','esi','edi']; { so many because what does Freemem!}

{ Length in assembler. 1/3 of Pascal size, and fit for inline}
Function Length (Var S : AnsiString) : Longint; ASSEMBLER;

ASM
                   movl    8(%ebp),%eax
                   movl    (%eax),%eax           // remove if no VAR parameter
                   testl   %eax,%eax
                   je      .LALengthEnd
                   movl    -8(%eax),%eax
.LALengthEnd:
END['EAX'];

Procedure Decr_Ansi_Ref(Var S : AnsiString);assembler;

ASM
                   movl    8(%ebp),%eax
                   movl    (%eax),%eax
                   test    %eax,%eax
                   je      .LDecransiexit
                   mov     -4(%eax),%ebx          //  load reference
                   test    %ebx,%ebx
                   js      .LDecransiexit          //  constant (-1)?
                   decl    -4(%eax)
                                                  //  in case DisposeAnsiString
                                                  //  is updated to check ref
                   jne     .LDecransiexit          //  mov doesn't change flags.
                   movl    8(%ebp),%eax
                   pushl   %eax
                   call    _DISPOSEANSISTRING$ANSISTRING
.LDecransiexit:
END ['eax','ebx','ecx','edx','esi','edi']; { so many because what does called procedure!}

Procedure Incr_Ansi_Ref (Var S : AnsiString);assembler;

ASM
                   movl    8(%ebp),%eax
                   movl    (%eax),%eax
                   test    %eax,%eax
                   je      .LIncrexit
                   mov     -4(%eax),%ebx
                   test    %ebx,%ebx
                   js      .LIncrexit
                   incl    -4(%eax)
.LIncrexit:
END ['eax','ebx'];

Procedure AssignAnsiString (Var S1 : AnsiString; S2 : Pointer); ASSEMBLER;

ASM
            mov     12(%ebp),%ebx           // Load S2, and test if empty
            mov     8(%ebp),%eax            // Load in case empty.
            test    %ebx,%ebx
            jne     .LAssignS2NotEmpty
            mov     %ebx,%eax
            mov     -4(%eax),%ebx           // Load S2.ref
            test    %ebx,%ebx
            jns     .LAssignS2NoConstant
            mov     -8(%eax),%eax           // Constant, load length
            pushl   %eax
            call    _NEWANSISTRING$LONGINT  // Allocate room for the copy.
            mov     %eax,%edi
            mov     12(%ebp),%esi           // Load S2
            mov     -8(%esi),%ecx           // S2.length to copyofs2.length
            mov     %ecx,-8(%edi)
            incl    %ecx                    // copy zero-byte
            rep
             movsb                          // eax=temp
            jmp     .LAssignS2OK
.LAssignS2NoConstant:
            incl    -4(%eax)               // increase S2.ref
                                           // eax=s2=temp
.LAssignS2NotEmpty:
.LAssignS2OK:
            pushl %eax                   // Save temp
                                         // decrease reference of S1
	    pushl 8(%ebp)                // also disposes when necessary
	    call  _DECR_ANSI_REF$ANSISTRING
	    popl  %ebx
	    mov   8(%ebp),%eax           // Load S1
	    mov   %ebx,(%eax)            // S1:=Temp;
	
END ['eax','ebx','ecx','edx','esi','edi']; { so many because what does called procedure!}

Procedure UniqueAnsiString (Var S : AnsiString); ASSEMBLER;

ASM
                mov    8(%ebp),%eax             // Load S to %ebx
                mov    (%eax),%eax
                test   %eax,%eax
                je     .LUniqnil                // NIL?
                mov    -4(%eax),%ecx
                cmp    $1,%ecx                  // Ref>1?
                jbe    .LUniqnil
                pushl  %eax                    // Copy string
                pushl  -8(%eax)
                call   _NEWANSISTRING$LONGINT
                pop    %esi
                mov    %eax,%edi
                mov     -8(%esi),%ecx           // S.length to CopyofS2.length
                mov     %ecx,-8(%edi)
                incl    %ecx
                rep
                 movsb                         // Copy.
                push    %eax                   // Save new pointer.
                pushl   8(%ebp)                // Decrease ref
	        call    _DECR_ANSI_REF$ANSISTRING
	        pop     %ebx
	        mov     8(%ebp),%eax           // Store new pointer
	        mov     %ebx,(%eax)
.LUniqnil:
END ['eax','ebx','ecx','edx','esi','edi']; { so many because what does called procedure!}


Procedure SetLength (Var S : AnsiString; l : Longint); ASSEMBLER;

ASM
        movl	8(%ebp),%eax                    // Load pointer adress
	movl	(%eax),%eax                     // it's value
	mov     12(%ebp),%ebx                   // and L
	test    %ebx,%ebx                       // L>0
	je      .LSetLengthNIL
	testl	%eax,%eax                       // S=NIL?
	jne     .LSetLengthPointer_NotNIL
	pushl   %ebx
	call     NewAnsiString                  // S=NIL, alloc new space
	mov     8(%ebp),%ebx                    // Load adress of S
	mov     %eax,(%ebx)                     // Save new pointer
	mov     12(%ebp),%ebx                   // reload L
	mov     %ebx,-8(%eax)                   // S^.Len:=L
	movb    $0,(%eax,%ebx,1)                // S[L]=#0
	jmp     .LSetLengthDone
	
.LSetLengthPointer_NotNIL:
        cmp     %ebx,-12(%eax)                  // L>S^.Allocated bytes
	jae    .LSetLengthReallocate            // then Reallocate.
	cmpl    $1,-4(%eax)                     // Reference<>1?
	je     .LSetLengthNoReallocate
.LSetLengthReallocate:                          // Reallocate
        pushl  %ebx
        call     NewAnsiString                  // alloc new space
        mov    8(%ebp),%ebx                     // Load pointer S
        mov    (%ebx),%esi                      // Load S^
        mov    -8(%esi),%ecx                    // Load S^.len
        mov    %eax,%edi
        test   %ecx,%ecx                        // >0?
        je     .LMoveNotNecessary
        inc    %ecx                             // Then move len+1 bytes
        rep
        movsb
.LMoveNotNecessary:
        pushl  %eax                             // Save fresh space
        push   %ebx                             // push old pointer
        call  _Decr_Ansi_Ref$LONGINT            // decrease ref old pointer
        pop    %eax
        mov    8(%ebp),%ebx
        mov    %eax,(%ebx)                      // S:=Temp, update pointer.
.LSetLengthNoReallocate:
        mov    12(%ebp),%ebx                    // S^.Len:=L;
        mov    %ebx,-8(%eax)
        jmp   .LSetLengthDone
.LSetLengthNIL:
        pushl  8(%ebp)
        call  _Decr_Ansi_Ref$LONGINT            // decrease ref S.
        mov    8(%ebp),%eax
        movl   $0,(%eax)
.LSetLengthDone:
END['EAX','EBX','ECX','EDX','ESI','EDI'];


{Florian: These are fixed, and corrected for that first char=1,
           also nonexistant is 0 again}

Function Pos (SubChar : CHAR; Source : AnsiString) : Longint;

var i       : longint;
    DiffLen : LONGINT;

begin
 i := 0;
 DiffLen:=length (Source);
 while (i < DiffLen) do
   begin
    IF PChar(Source)[i]=SubChar THEN
     BEGIN
      Pos:=i+1;
      EXIT;
     end;
    inc (i);
   END;
 Pos:=0;
end;

{The same, but in ultrafast assembler}
Function Pos (SubChar : CHAR; Source : AnsiString) : Longint; ASSEMBLER;

ASM
                      movl   10(%ebp),%edi       // Load String
//                    mov    (%edi),%edi         // uncomment if you add CONST
                      cld
                      mov    -8(%edi),%ecx       // Load length
                      inc    %ecx
                      mov    %ecx,%ebx
                      movl   8(%ebp),%eax        // Load char
                      repne
                       scasb
                      jne   .LPosNotFound
.LPosNotFound:        sub   %ecx,%ebx
                      mov   %ebx,%eax
END['EAX','EBX','ECX','EDI'];



Function Pos (Var Substr : AnsiString; Var Source : AnsiString) : Longint;

var i,k,len : longint;          { j was eliminated in the proces}
    DiffLen : LONGINT;

begin
 len:=Length(SubStr);                 { Check length pattern}
 if Len=0 then                        { Zero chars, don't POS}
  BEGIN
   Pos:=0;                           { -1= NOT FOUND}
   EXIT;
  END;

 IF Len=1 THEN                      { One char, use overloaded CHAR variant}
   BEGIN                             { Not implemented yet}
    pos:=Pos(substr[1],Source);      { No recursion. Overloaded!}
    EXIT;
   END
 i := 0;

 DiffLen:=length (Source) - len;     { Both to keep Length (Source) in variable
                                       and while were doing that, naah, don't
                                       scan a char too much :-)}
 while (i <= DiffLen) do
   begin
    IF PCHAR(Source)[i]=PCHAR(SubStr)[0] THEN  {Compare char 0 }
     BEGIN
      k:=1;                          { Match char 1..(len-1)}
      WHILE (PCHAR(Source)[i+k]=PCHAR(SubStr)[k]) AND (k<len) DO
       INC(k);
      IF k=len THEN                  { Check # of matched characters}
       BEGIN
        Pos := i+1;                    { FOUND!}
        EXIT;
       END;
     end;
   inc (i);
   end; {WHILE}
 pos :=0;                          { Not Found}
end;

