{ Generic routines module. Often system dependant stuff.
   This is a unit of the XTDLIB/FPC package
   COPYRIGHT (C) 1993..1998 by Marco van de Voort,  All Rights Reserved
   Free for non-commercial use. See license.txt.
   (www.stack.nl/~marcov/xtdlib.htm)   }
UNIT ELib;

INTERFACE

{$DEFINE UseAsm}

{$I syseq.inc}

{$IFDEF GO32V2}
Uses Go32,Dos; {RealIntr required for some stuff (Only Go32V2.}
{$ELSE}
Uses Dos;
{$ENDIF}

{$IFDEF Turbo}
 TYPE CARDINAL=LONGINT;
{$ENDIF}

TYPE CHARSET = SET OF CHAR;

{Why isn't this one included in the RTL? Logical sequence
FillChar, FillWord and FillCard? Just because it isn't included in Turbo?
This is a 32-bit compiler!}
PROCEDURE FillCard(var x;count : LONGINT;value : cardinal);

{ Get a key, even if it's a function key (first value is zero, weird
 combinations(like ctrl-shift-alt-T) not supported. If function key is detected
 return second value SHL 8.
 This procedure behaves bad while debugging in the BP-IDE. Why? Runtime is
 no problem }
FUNCTION GetKey:WORD;


{ Compare String}
FUNCTION Compare(S1,S2:String): BOOLEAN;

{ Cursor movement. These primitives exist in Crt, but aren't exported}

{$IFNDEF Linux}

{BIOS functions, only in dos and dos-ish OSes}

{$IFNDEF Turbo}         {Turbo versions are in BPGo32.pas}
{Set cursorsize, SetCurSize($090A) is the same as Crt.CursorOn}
PROCEDURE SetCursorSize(A:WORD);

{Get cursorsize, save them in a 16-bits value}
FUNCTION GetCursorSize:WORD;
{$ENDIF}
{$ENDIF}

{ Trunc(SQR(InData)).  Square root rounded down. Entirely integer. No FPU
Old 386sx trick :-) Probably not faster than CoPro anymore.}
FUNCTION ISqrt(Indata:CARDINAL):CARDINAL;

{Search for Value in adress space starting on address adr, which is
count bytes long. Pascal'led rep scasb function.
Adr is VAR but not written.}
FUNCTION ScanR(VAR Adr;Value : BYTE;Count: LONGINT):LONGINT;

{ Used to play with addresses. Returns a pointer to an (adress + an offset)}
{FUNCTION AddAddr(Addr;Index:LONGINT):POINTER;}


{$IFDEF Go32V2}
procedure set_fs_to_dosmem;
{$ENDIF}

IMPLEMENTATION

{$IFNDEF Win32}
Uses Crt;
{$ELSE}
Uses WInCrt
{$ENDIF}

FUNCTION GetKey:WORD;

VAR InKey: WORD;

BEGIN
 InKey:=ORD(ReadKey);
 IF InKey=0 THEN InKey:=ORD(ReadKey) SHL 8;
 GetKey:=InKey;
END;

{$IFDEF Go32V2}

procedure set_fs_to_dosmem; assembler;
asm
   movw DOSMEMSELECTOR, %ax
   movw %ax, %fs
end;
{$ENDIF}



{ ---------- String routines. ---------

Most are simple, I banged them in to get some stuff working.
You'd better take some nice unit from STRINGS.SWG, and kill this junk.}


{ Compare String}
FUNCTION Compare(S1,S2:String): BOOLEAN;

VAR A : WORD;

BEGIN
Compare:=FALSE;
 IF Length(S1) = Length(S2) THEN
 BEGIN
  Compare:=TRUE;
  FOR A:=1 TO Length(S1) DO
   IF S1[A]<>S2[A] THEN
   Compare:=FALSE;
  END;
END;

{$IFNDEF Linux}
{$IFNDEF Turbo}
{Get cursorsize, save them in a 16-bits value}

FUNCTION GetCursorSize:WORD;

{$ifdef GO32V2}
    var     regs : trealregs;
{$endif GO32V2}
      begin
{$ifndef GO32V2}
         asm
            movb   $3,%ah
            xorb   %bh,%bh
            pushl  %ebp
            int    $0x10
            popl   %ebp
            movl   %ecx,%eax
         end;
{$else GO32V2}
            regs.realeax:=$0300;
            regs.realebx:=0;
            realintr($10,regs);
            GetCursorSize:=INTEGER(regs.realecx);
{$endif GO32V2}
      end;

{Set cursorsize}
PROCEDURE SetCursorSize(A:WORD);

{$ifdef GO32V2}
    var     regs : trealregs;
{$endif GO32V2}
      begin
{$ifndef GO32V2}
         asm
            movb   $1,%ah
            movl   A,%ecx
            pushl  %ebp
            int    $0x10
            popl   %ebp
         end;
{$else GO32V2}
            regs.realeax:=$0100;
            regs.realecx:=A;
            realintr($10,regs);
{$endif GO32V2}
      end;

{$ENDIF}
{$ENDIF}
{$IFDEF UseAsm}
FUNCTION ISqrt(Indata:CARDINAL):CARDINAL; Assembler;

ASM
                            movl 8(%ebp),%eax
                            cmp  $2,%eax
                            jb   .LSqrtRootFound
                            xor  %ebx,%ebx
       .LISQRTLOOP:         mov  %ebx,%ecx
                            shl  $1,%ecx
                            inc  %ecx
                            inc  %ebx
                            subl %ecx,%eax
                            ja  .LISQRTLOOP
                            dec  %ebx
.LSqrtRootFound:            mov %ebx,%eax

END['EAX','EBX','ECX'];

FUNCTION ScanR(VAR Adr;Value : BYTE;Count: LONGINT):LONGINT;ASSEMBLER;

ASM
                            movl  Adr,%edi
                            movb  Value,%al
                            movl  Count,%ecx
                            mov   %ecx,%ebx
                            cld
                            repne
                            scasb
                            jne  .LCharNotFound
                            inc   %ecx
                            subl  %ecx,%ebx
                            mov   %ebx,%eax
                            jmp .LEndScanr
.LCharNotFound:             movl $-1,%eax
.LEndScanr:
end['EAX','EBX','ECX','EDI'];

{Why isn't thisone included in the RTL?}
procedure fillcard(var x;count : LONGINT;value : cardinal); ASSEMBLER;

asm

        movl 8(%ebp),%edi
        movl 12(%ebp),%ecx
        movl 16(%ebp),%eax
        cld
        rep
        stosl

end ['EAX','ECX','EDI'];

{$ELSE}
FUNCTION ISqrt(Indata:CARDINAL):CARDINAL;

VAR B,C : CARDINAL;

BEGIN
 IF InData>1 THEN
  BEGIN
   B:=0; C:=0;
   REPEAT
    InData:=InData-C;
    C:=(B shl 1)+1;
    INC(B);
   UNTIL InData<C;
   dec(B);
  END
 ELSE
  B:=Indata;
 ISqrt:=B;
END;

FUNCTION ScanR(VAR Adr;Value : BYTE;Count: LONGINT):LONGINT;

{$IFDEF Turbo}

TYPE ByteArr=ARRAY[0..60000] OF BYTE;
    BytePtr=^ByteArr;

{$ELSE}
TYPE BytePtr=^Byte;
{$ENDIF}

VAR I : LONGINT;
    BP:Byteptr;

BEGIN
 I:=0;
 BP:=@Adr;
 {$IFDEF Turbo}
 WHILE (I<Count) AND (BP^[I]<>Value) DO
  INC(I);
 {$ELSE}
   WHILE (I<Count) AND (BP[I]<>Value) DO
  INC(I);
 {$ENDIF}
 IF I=Count THEN
  I:=-1;
 ScanR:=I;
END;

procedure fillcard(var x;count : LONGINT;value : cardinal);

{$IFDEF Turbo}

TYPE CardArr=ARRAY[0..10000] OF LONGINT;
    LPtr=^CardArr;
{$ELSE}
TYPE LPtr=^CARDINAL;
{$ENDIF}

VAR LP : LPtr;
    I  : LONGINT;

BEGIN
 LP:=@X;
 IF Count>0 THEN
  FOR I:=0 TO Count-1 DO
  {$IFDEF Turbo}
   LP^[I]:=Value;
  {$ELSE}
   LP[I]:=Value;
  {$ENDIF}
END;
{$ENDIF}

END. { Aargh, 275 lines already?}

