Unit EMP3;
{ Some simple MP3 stuff. (no decoding, TAGS/bitrate detection, what you see when
 you press alt-3 in WinAmp)

   This is a unit of the XTDLIB/FPC package
   COPYRIGHT (C) 1993..1998 by Marco van de Voort,  All Rights Reserved
   Free for non-commercial use. See license.txt.
   (www.stack.nl/~marcov/xtdlib.htm)

Reading/writing of MP3-Tags. Simple MP3-detection(+bitrates, mpeg version
and layer etc).

The purpose of these routines is to ease writing small tools to manage huge
trees of MP3 files (currently I've 20-25 CDs) (rename all files, run a certain
file which converts the filenames to tags etc). It's not the start of a WinAmp.

}
INTERFACE

CONST

{$I genretag.inc} {Enumerations for GenreID byte and an array with textual
                            descriptions}

 MP3_TAG_ALLOK     = 0;
 MP3_TAG_NOT_FOUND = 1;   {Returned by GetTag when no tag was found}
 MP3_TAG_GET_ERROR = 2;   {Returned by GetTag when retrieving tag failed (probably
                            file too small)}
 MP3_TAG_PUT_ERROR = 3;   {Returned by GetTag when saving tag failed (probably
                            disk full or file/network write protected)}

  BitRates : ARRAY [1..2,1..3,1..15] OF INTEGER= (
  ((0,32,64,96,128,160,192,224,256,288,320,352,384,416,448),
   (0,32,48,56, 64, 80, 96,112,128,160,192,224,256,320,384),
   (0,32,40,48, 56, 64, 80, 96,112,128,160,192,224,256,320)),
  ((0,32,48,56, 64, 80, 96,112,128,144,160,176,192,224,256),
   (0, 8,16,24, 32, 40, 48, 56, 64, 80, 96,112,128,144,160),
   (0, 8,16,24, 32, 40, 48, 56, 64, 80, 96,112,128,144,160))  );

   SampleFreq : ARRAY[1..2,0..2] OF WORD=  (( 44100 , 48000 , 32000),
                                            ( 22050 , 24000 , 16000));

TYPE
 ID3TAG = Record { Used for easy update'ing, tags are internally array of char}
                  Songname       : String[30];
                  Artist         : String[30];
                  Album          : String[30];
                  Year           : String[4];
                  Comment        : String[30];
                  GenreID        : Byte;
                  end;

{-------------------------------- Tags -----------------------------------}

{Get MP3 tag from file "Filename". Convert to Pascal string record, return
status (see above), can also be used to detect if a tag is present.}
FUNCTION GetTag(CONST Filename:String;VAR Tag : ID3Tag ):LONGINT;

{Append/replace MP3 tag to file "Filename". Convert Pascal string record to
array of char tag, return status (see above)}
FUNCTION SetTag(CONST Filename:String;CONST Tag : ID3Tag ):LONGINT;

{----------------------------- Mp3 detection ------------------------------}

{Detect of file is MP3 file. If yes, than return 32-bit identifier as a LONGINT
(e.g. FF FE 01 02 becomes 0201FEFF) If it isn't, return -1}
FUNCTION IsMp3(FileName:String):LONGINT;

{----------------------------- Dumping data ------------------------------}

{ Dump a TAG (record created with GetTag}
Procedure DumpTag(Tag:ID3Tag);

{ Dump a mp3 identifier (mosttimes the first 4 bytes in an mp3 file)}
Procedure DumpIdentifier(Ident:LONGINT);

IMPLEMENTATION

Uses EPasStr,Dos;

const
 _TAG   :Array[0..2] of Char=('T','A','G');

type
  Internal_ID3TAG = packed Record { Fields are padded with spaces (#32) }
                     TAG             : Array[0..2] of Char; { 'TAG' }
                     Songname        : Array[1..30] of Char;
                     Artist          : Array[1..30] of Char;
                     Album           : Array[1..30] of Char;
                     Year            : Array[1..4] of Char;
                     Comment         : Array[1..30] of Char;
                     GenreID         : Byte;
                     end;
  PLONGINT= ^LONGINT;

PROCEDURE RecFixField(VAR ArrChar;VAR Target: String; FieldLength : LONGINT);

BEGIN
 Move (ArrChar,Target[1],FieldLength);
 Target[0]:=CHR(FieldLength);
 RTrim(Target,' ');
 LTrim(Target,' ');
END;

PROCEDURE RealTagToTagRec(CONST RealTag : Internal_ID3TAG; VAR Tag : ID3TAG);

BEGIN
 RecFixField(RealTag.SongName,Tag.SongName,30);
 RecFixField(RealTag.Artist,Tag.Artist,30);
 RecFixField(RealTag.Album,Tag.Album,30);
 RecFixField(RealTag.Year,Tag.Year,4);
 RecFixField(RealTag.Comment,Tag.Comment,30);
 Tag.GenreID:=RealTag.GenreID;
END;

PROCEDURE RealFixField(VAR ArrChar;CONST Target: String; FieldLength : LONGINT);

VAR Int : LONGINT;
    L   : PCHAR;

BEGIN
 L:=@ArrChar;
 Int:=Length(Target);
 IF Int>FieldLength THEN
  Int:=FieldLength;
 Move (Target[1],L[0],Int);
END;

PROCEDURE TagRecToRealTag(Var RealTag : Internal_ID3TAG; CONST Tag : ID3TAG);

BEGIN
 FillChar(Realtag,SIZEOF(Internal_ID3TAG),32);
 RealFixField(RealTag.SongName,Tag.SongName,30);
 RealFixField(RealTag.Artist,Tag.Artist,30);
 RealFixField(RealTag.Album,Tag.Album,30);
 RealFixField(RealTag.Year,Tag.Year,4);
 RealFixField(RealTag.Comment,Tag.Comment,30);
 RealTag.GenreID:=Tag.GenreID;
 Move(_TAG,RealTag.TAG,3);
END;


FUNCTION GetTag(CONST Filename:String;VAR Tag : ID3Tag ):LONGINT;

VAR Realtag : Internal_ID3TAG;
    Dummy   : LONGINT;
    F       : File;

BEGIN
  Assign(F,filename);
  Reset(F,1);
  Seek(F,FileSize(F)-128);
  BlockRead(F,realTAG,SizeOf(internal_ID3TAG),Dummy);
  system.Close(F);
  if dummy<>SizeOf(Internal_ID3TAG) THEN
   Dummy:=MP3_TAG_GET_ERROR
  ELSE
    IF RealTag.TAG=_TAG THEN
     BEGIN
      Dummy:=0;
      RealTagToTagRec(RealTag,Tag);
     END
    ELSE
     BEGIN
      Dummy:= MP3_TAG_NOT_FOUND;
      FillChar(Tag,SIZEOF(ID3Tag),32);
      Tag.GenreID:=0;
     END;
 GetTag:=Dummy;
END;

FUNCTION SetTag(CONST Filename:String;CONST Tag : ID3Tag ):LONGINT;

VAR Realtag : Internal_ID3TAG;
    Dummy   : LONGINT;
    SmallTag: ARRAY[0..2] OF CHAR;
    F       : File;

BEGIN
  Assign(F,filename);
  Reset(F,1);
  Seek(F,FileSize(F)-128);
  BlockRead(F,SmallTag,3,Dummy);
  IF SmallTag=_TAG THEN
   Seek(F,FileSize(F)-128)
  ELSE
   Seek(F,FileSize(F));
  TagRecToRealTag(RealTag,Tag);
  BlockWrite(F,realTAG,SizeOf(Internal_ID3TAG),Dummy);
  system.Close(F);
  if dummy<>SizeOf(Internal_ID3TAG) THEN
   SetTag:=MP3_TAG_PUT_ERROR
  ELSE
   SetTag:=0;
END;


Procedure DumpTag(Tag:ID3Tag);
begin
 WriteLn('   Song: "'+TAG.songname+'"');
 WriteLn(' Artist: "'+TAG.artist+'"');
 WriteLn('  Album: "'+TAG.album+'"');
 WriteLn('   Year: "'+TAG.year+'"');
 WriteLn('Comment: "'+TAG.comment+'"');
 WriteLn('  Genre: "'+Genre[TAG.genreID]+'" (ID #',TAG.genreID,')');
end;


FUNCTION IsMp3(FileName:String):LONGINT;
VAR
    F :File;
    Buf  : ARRAY[0..12287] OF BYTE;
    I,J : LONGINT;

BEGIN
    Assign(F,FileName);
    Reset(F,1);
    BlockRead(F,Buf,SIZEOF(Buf));
    Close(F);
    I:=0; J:=255;
    WHILE (I<SIZEOF(Buf)) AND (J=255) DO
     BEGIN
      IF Buf[I]=255 THEN
       BEGIN
        IF ((Buf[I+1] AND 240)=240) THEN
         BEGIN {Probably MP3}
           {Implement sanity checks here}
           IF Buf[I+1] <>255 THEN               { Just to avoid $FFFF}
            J:=0;
         END;
       END;
      INC(I);
     END;
    IF I=SIZEOF(Buf) THEN
     IsMp3:=-1
    ELSE
     IsMp3:=PLongint(@buf[I-1])^;
END;

PROCEDURE YesNo(Fl: BOOLEAN);

BEGIN
 IF Fl THEN
  WriteLn('Yes')
 ELSE
  WriteLn('No');
END;

PROCEDURE DumpIdentifier(Ident:LONGINT);

VAR S    : String;
    Mpeg : LONGINT;
    Layer: LONGINT;
    P    : PChar;

CONST MpLay : String ='MPeg x Layer x';

BEGIN
 MPeg:=2; P:=@MpLay;
 IF (Ident AND $800)=$800 THEN
  DEC(Mpeg);
 Layer :=((Ident AND $600) SHR 9)+1;
 WriteLn('MPEG ',MPeg,' Layer ',Layer+1);
 Write('CRC protected : '); YesNo(((Ident AND $100)<>0));
 Write('Padding       : '); YesNo(((Ident AND $1000000)<>0));
 Write('Private       : '); YesNo(((Ident AND $2000000)<>0));
 Writeln('Mode          : ',(Ident AND $C0000000) SHR 30);
 Writeln('Mode Ext.     : ',(Ident AND $30000000) SHR 28);
 Write('Copyright     : '); YesNo((Ident AND $08000000)<>0);
 Write('Original      : '); YesNo((Ident AND $04000000)<>0);
 Write('Emphasis      : '); YesNo((Ident AND $03000000)<>0);
 Writeln('Bitrate       : ', BitRates[mpeg,Layer,(Ident AND $F00000) SHR 20]);
 Writeln('Samplefreq    : ', SampleFreq[mpeg,(Ident AND $C0000) SHR 18]);
END;

{ Unused. WinAmp code is probably better.
function bitrate(CONST Filename : String):LONGINT;
var
    F : File;
    br:word;
    w:word;
    buff:array[1..3] of byte;
begin
 Assign(F,Filename);
 reset(F,1);
 blockread(f,w,2);
 blockread(f,buff[3],1);
 Close(F);
 case byte(buff[3] shr 4) of
	   0:br:=0;
	   1:case w of
	       $E2FF,$F2FF,$E3FF:br:=8;
	       $F3FF,$FAFF,$FBFF,$FDFF:br:=32;
	     end;
	   2:case w of
	       $E2FF,$F2FF,$F3FF,$E3FF,$FAFF,$FBFF:br:=16;
	       $FDFF:br:=48;
	     end;
	   3:case w of
	       $E2FF,$F2FF,$E3FF:br:=24;(* 22khz *)
	       $F3FF,$FAFF,$FBFF:br:=48;
	       $FDFF:br:=56;
	     end;
	   4:case w of
	       $E2FF,$F2FF,$E3FF:br:=32;(* 22khz *)
	       $F3FF,$FAFF,$FBFF:br:=56;
	       $FDFF:br:=64;
	     end;
	   5:case w of
	       $E2FF,$F2FF,$F3FF,$E3FF,$FAFF,$FBFF:br:=64;
	       $FDFF:br:=80;
	     end;
	   6:case w of
	       $E2FF,$F2FF,$E3FF:br:=48;(* 22khz *)
	       $F3FF,$FAFF,$FBFF:br:=80;
	       $FDFF:br:=96;
	     end;
	   7:case w of
	       $E2FF,$F2FF,$E3FF:br:=56;(* 22khz *)
	       $F3FF,$FAFF,$FBFF:br:=96;
	       $FDFF:br:=112;
	     end;
	   8:case w of
	       $E2FF,$F2FF,$E3FF:br:=64;(* 22khz *)
	       $F3FF,$FAFF,$FBFF:br:=112;
	       $FDFF:br:=128;
	     end;
	   9:case w of
	       $E2FF,$F2FF,$E3FF,$F3FF,$FAFF,$FBFF:br:=128;
	       $FDFF:br:=160;
	     end;
	  10:case w of
	       $E2FF,$F2FF,$E3FF:br:=96;(* 22khz *)
	       $F3FF,$FAFF,$FBFF:br:=160;
	       $FDFF:br:=192;
	     end;
	  11:case w of
	       $E2FF,$F2FF,$E3FF:br:=112;(* 22khz *)
	       $F3FF,$FAFF,$FBFF:br:=192;
	       $FDFF:br:=224;
	     end;
	  12:case w of
	       $E2FF,$F2FF,$E3FF:br:=128;(* 22khz *)
	       $F3FF,$FAFF,$FBFF:br:=224;
	       $FDFF:br:=256;
	     end;
	  13:br:=256;
	  14:br:=320;
	  15:br:=0;
	end;
bitrate:=br;
end;}

END.
