Unit EWinApi;
{ Modula2 style TextWindowing. TopLeft=(1,1) based however, to keep TP-Crt
   compability of coordinates. See EWinApi.htm for all features.

VIDEO-API version test source. NOT FULLY FUNCTIONAL!

   This is a unit of the XTDLIB/FPK package
   COPYRIGHT (C) 1993..1998 by Marco van de Voort,  All Rights Reserved
   Free for non-commercial use. See license.txt.
   (www.stack.nl/~marcov/xtdlib.htm)
   Free for non-commercial use.

}

INTERFACE

{XTDFPK wide conditionals}

{$I syseq.inc}

{$Info EWinApi : Video version}

Uses Video;

{EWinApi specific conditionals}

{$DEFINE WindowCheck}        {Should coordinates and window-descriptors get
                              checked for integrity?}


{$IFDEF Linux}
 {$UNDEF Linux_Ansiwrap}       {Use ansi under Linux to fend wrap off?}
{$ENDIF}

{ Patch for BP}
{$IFDEF Turbo}
 TYPE CARDINAL=LONGINT;
{$ENDIF}
{Go32 not needed for Linux, ELib contains the cursorroutines, which can't be
     used under Linux}

{ Some styles for windows}
CONST
      Style1='ڿĳ';  { Styles. Only the first 8 are used for pulldown}
      Style2='ɻȼͺ';  { menues, but the other 2 are included for future}
      Style3='ոԾͳ';  { use by other procedures}
      Style4='ַӽĺ';

TYPE
      AbsCoord= INTEGER; {Coordinates with upperleft =1,1, on physical screen}
      RelCoord= INTEGER; {Coordinates with upperleft =1,1, on Windowed screen}

      WinType = ^WinDataRec; {The main Window type}

      BufType = ARRAY[0..9999] OF BYTE; { ok until 250x200 }
      BufPtr  = ^BufType;

      WinErrorType=(WinOk,XTooBig,YTooBig,NilWindow,BadIdent,NilBuffer,ScreenTooWide);
      WinErrorProc=Procedure(WError:WinErrorType);

      WinDef    = RECORD
                   X1,Y1,
                   X2,Y2          : AbsCoord;       { Coords of Window}
                   Foreground     : BYTE;           { Initial colors of}
                   Background     : BYTE;           {   window}
                   FrameOn        : BOOLEAN;        { if frame            }
                   FrameDef       : String[15];     { Bordertype, see above}
                   FrameFore      : BYTE;           { Colors of the frame}
                   FrameBack      : BYTE;
                   END;

     WinDataRec= RECORD  (* Internal *)
                  Next            : WinType;
                  Ident           : LONGINT;  { Identifier $13579BDF, to
                                                detect record-corruption}
                  Hidden          : BOOLEAN;  { Is Window hidden}
                  Def             : WinDef;   { Windef as it is now,
                                                 not necessarily the same as
                                                 original definition}
                  Buffer          : BufPtr;   { Contents of Window are
                                               copied here}
                  Title           : PChar;    { Title (in framewindow, not
                                                 implemented yet}
                  Xi1,Yi1,                      { Part of Window that can be }
                  Xi2,Yi2         : AbsCoord; { written. Same for normal window,
                                                smaller for frame window }
                  CurX,
                  CurY            : RelCoord; { Used to backup cursorpositions
                                                while manipulating windows}
                  CursorState     : WORD;
                  END;

VAR Height,
    Width      : INTEGER; { Width of the Screen. Should be equal to
                            Crt.ScreenCols, but that variable is a Crt internal. }
    FullScreen : WinType; { "Background Screen", filled with startup screen}
    {$IFDEF WindowCheck}
      WinError   : WinErrorProc;        {Errorhandler}
    {$ENDIF}


{Open a window described by a WinDef record}
FUNCTION WinOpen(WD : WinDef):WinType;

{Put a title centered on the top of the window's frame, in the frame colors}
PROCEDURE SetTitle(W:WinType;Title:PChar);

{Close window, restore screen underneath}
PROCEDURE WinClose(VAR W:WinType);

{Put a window on top, and redirect output of Crt to it}
PROCEDURE Use(W:WinType);

{Hide a window}
PROCEDURE Hide(W:WinType);

{Unhide a Window}
PROCEDURE UnHide(W:WinType);

{Change dimensions and/or position of window,
 Only contents which fit in new window are copied, if the new window
 is bigger in one or both dimensions, the rest is filled with spaces with the
 current attributes for that window}
PROCEDURE Change(W: WinType; OX1,OY1,OX2,OY2: AbsCoord);

{Move window around without changes to window dimensions,
  A LOT faster than Change.}
PROCEDURE WinMove(W: WinType;OX1,OY1: AbsCoord);

{Clear Window W, with current attributes and GotoXY(1,1)}
PROCEDURE Clear(W:WinType);

{Clone a window, make the clone hidden}
FUNCTION WinClone(W:WinType):WinType;

{Write string to current Window, and wrap the text. WrapWriteln adds
    an linefeed}
PROCEDURE WrapWrite(CONST Towrite:String);
PROCEDURE WrapWriteLn(CONST Towrite:String);

PROCEDURE GotoXY(X,Y:LONGINT);

IMPLEMENTATION

Uses Strings {$IFDEF DosFPC},Go32,ELib{$ENDIF}
                 {$IFDEF turbo} ,bpgo32 {$ENDIF};

{Tune constants. In the ideal situation, Spare would be zero, and
   Multyplyer 1.
 Used when debugging, to check if nr bytes copied is correct.

 I haven't changed/retested these in a while. }

CONST Spare = 16; { Just in case, extra space allocated for Window buffer}
      {$IFDEF Linux}
        Multiplyer=2;
      {$ELSE}
       Multiplyer=1; { All allocations for the Winbuffer are scaled with this
                      number. Dos is getting quite safe}
      {$ENDIF}


PROCEDURE GotoXY(X,Y:LONGINT);

BEGIN
 SetCursorPos(X,Y);
END;

{--------------------------------------------------------------------

 Start OF OS-DEPENDANT ROUTINES.

 WinWindowToBuf  : Reads a window from the (virtual) screen and stores in
                    the window-buffer. (BP/DosFPC and Linux version)
 UpdateScreen    : Updates one line on the screen (one procedure,
                    but with a lot of conditional code in it)
 OTTyColor       : (Linux only) TextColor and TextBackground in one.
--------------------------------------------------------------------}

VAR WindowList : WinType;

VAR ScreenSeg  : WORD;

PROCEDURE WinWindowToBuf(W:WinType);
  {Plop a window to the buffer, Caller has to make sure the buffer is
  for the right window size, version with Wintype as parameter.

  This routine captures output in the window when changing windows}

  VAR XDiff,A,B: INTEGER;

  BEGIN
   WITH W^.Def DO
    BEGIN
     XDiff:=X2-X1+1;      { Width of Window }
     FOR A:=Y1-1 TO Y2-1 DO
      IF A<Width THEN  {Videobuf is array of word !}
       Move(VideoBuf^[Width*A+X1-1],W^.Buffer^[2*(A-(Y1-1))*XDiff],
                                                               XDiff*2);
    END;
    {Save colors and cursorpositions}
   W^.CurX:=WhereX; W^.CurY:=WhereY;
   W^.Def.ForeGround:=TextAttr AND 15;
   W^.Def.BackGround:=TextAttr SHR 4;
   W^.CursorState:=GetCursorSize;
END;


{OS-dependant. One version with conditional code, maybe more versions if
 more targets are supported, just to keep it readable.}
PROCEDURE  UpdateScreen ( Xin1,Yin,Xin2 : LONGINT);
(* Updates the screen from the window buffer, most important procedure of
unit. *)

CONST InternalBufSize=132;

VAR WinVar  : WinType;
    V1,V2   : LONGINT;
    VX1,VX2 : LONGINT;
    Tmp     : LONGINT;
    Buf     : ARRAY[0..InternalBufSize*2-1] OF BYTE;
{$IFDef Linux}
    IsLastLine : BOOLEAN;   {Used to avoid scrolling on last line}
    A,
    Ind1,
    Ind2    : LONGINT;
{$ENDIF}

BEGIN
   {$IFDEF WindowCheck}
    IF (XIn2-XIn1)>InternalBufSize THEN {Internal safety}
     WinError(ScreenTooWide);
   {$ENDIF}
   FillWord(Buf[0],SIZEOF(Buf) SHR 1,32); {Fill buffer with black spaces
                                            Not necessary I think, unless some
                                            !@#!#$ user closes the fullscreen.}
    WinVar:=WindowList;               {Get top of Window list}
    WHILE WinVar<>NIL DO              {Parse to end}
     BEGIN
      WITH WinVar^ DO
       BEGIN
        IF ((YIn>=Def.Y1) AND (YIn<=Def.Y2)) AND NOT Hidden THEN
          BEGIN                       {Window in Y-range}
            vX1 := Def.X1; vX2 := Def.X2;
            IF (vX2>=XIn1) AND (vX1<=XIn2) THEN
             BEGIN                    {Window in X AND Y range}
              IF vX1<=XIn1 THEN       {Calculate overlap}
               V1:=XIn1
              ELSE
               V1:=vX1;
              IF vX2>=XIn2 THEN
               V2:=XIn2
              ELSE
               V2:=Vx2;
              Tmp:=V2-V1+1;           {V2..V1 is overlap Window with range
                                        (Xin1..XIn2 on line YIn) to redraw}
              IF Tmp>0 THEN     {Buffer on stack for all OSes.
                                  Maybe slower on Dos, but reduces flicker.}
               Move (Winvar^.Buffer^[2*((YIn-WinVar^.Def.Y1)*(Vx2-Vx1+1)+V1-Vx1)],
                         Buf[2*(V1-XIn1)],Tmp*2);
            END;
          END;
       END; {With}
      WinVar:=WinVar^.Next; {Ok, do next window :-)}
    END;

  { End-of window-tree parsing}

   Tmp:=XIn2-XIn1+1;
   IF Tmp>0 THEN
    Move(Buf,VideoBuf^[Width*(YIn-1)+XIn1-1],Tmp*2);
END;

{--------------------------------------------------------------------
 END OF OS-DEPENDANT ROUTINES. Some OS-dependandstuff exists below this line,
 but are rather simple (detection of screen dimensions), and can be handled
 by a small bit of conditional code.
--------------------------------------------------------------------}

{----------------------- Error Handling -----------------------}

{$IFDEF WindowCheck}

{Default error handler. Idiotic simple. Clear screen with standard attributes
and output a cryptic message}
Procedure InternalWinError(WError:WinErrorType);

BEGIN
 Window(1,1,Width,Height);
 TextColor(LightGray); TextBackGround(Black);
 ClrScr;
 Writeln('Internal Window Error ',ORD(WError),' program halted');
 HALT(64+ORD(WError));
END;

{Check window definition for bounderies. E.g. too large X or Y coordinates are
  set to resp Width and Height. Only called by WinOpen for now.}
FUNCTION CheckWinDef(VAR WD:WinDef):BOOLEAN;

VAR Fo : LONGINT;

BEGIN
 WITH WD DO
  BEGIN

     {Check for too big coordinates, make sure nothing weirds comes through}

   IF X1>Width THEN X1:=Width;
   IF X2>Width THEN X2:=Width;
   IF Y1>Height THEN Y1:=Height;
   IF Y2>Height THEN Y2:=Height;

   {Check for X2>=X1 and Y2>=Y1}

   IF X2<X1 THEN
    WinError(XTooBig);
   IF Y2<Y1 THEN
    WinError(YTooBig);
   Fo:=1;
   IF FrameOn THEN Fo:=3;             {Minimum window size framewindow is bigger}

   IF (X2-X1)<=Fo THEN                { If X-diff not big enough, resize a bit}
     IF (X2+Fo)>Width THEN
      BEGIN
       X2:=Fo; X1:=X2-Fo;
      END
     ELSE
       X2:=X1+Fo;

   IF (Y2-Y1)<=Fo THEN                {If Y-diff not big enough, resize a bit}
     IF (Y2+Fo)>Height THEN
      BEGIN
       Y2:=Fo; Y1:=Y2-Fo;
      END
     ELSE
       Y2:=Y1+Fo;

   {Coordinates are now ok, you could add checks like
     Foreground color<>background color etc here, but since Crt allows it,
     so do I.}
    END; {With}
END;

{Often called procedure which tests a window descriptor. Called in most
  procedures}
PROCEDURE CheckWin(W:WinType);

BEGIN
 IF W=NIL THEN
  WinError(NilWindow);
 IF W^.Ident<>$13579BDF THEN
  WinError(BadIdent);
 IF W^.Next<>NIL THEN
  IF W^.Next^.Ident<>$13579BDF THEN
   WinError(BadIdent);
 IF W^.Buffer=NIL THEN
  WinError(NilBuffer);
END;

{$ENDIF}


{ --------------------------------------------------------------------------
   Screenredraw.
   (WinFrame currently writes to the buffer instead of the screen to be more
    OS-independant, but it is still a more or less "draw" routine)
  -------------------------------------------------------------------------- }

PROCEDURE WinFrame(W:WinType);
{ OS-independant WinFrame - Draw frame in buffer instead of on screen}

TYPE WordArr=ARRAY[0..32000] OF WORD;

VAR Col         : WORD;
    B,B2        : LONGINT;
    WordBuf     : ^WordArr;

BEGIN
 {$IFDEF WindowCheck}
  CheckWin(W);
 {$ENDIF}
  IF W^.Def.FrameOn THEN
   BEGIN
    Col:=(ORD(W^.Def.FrameFore)+ (ORD(W^.Def.FrameBack) SHL 4)) SHL 8;
    WITH W^.Def DO
     BEGIN
      WordBuf:=@W^.Buffer^[0];
      B:=X2-X1+1;
      B2:=(Y2-Y1)*B;
      WordBuf^[0]:=ORD(W^.Def.FrameDef[1])+Col;
      FillWord(WordBuf^[1],B-1,ORD(W^.Def.FrameDef[5])+Col);
      WordBuf^[B-1]:=ORD(W^.Def.FrameDef[2])+Col;
      WordBuf^[B2]:=ORD(W^.Def.FrameDef[3])+Col;
      FillWord(WordBuf^[B2+1],B-1,ORD(W^.Def.FrameDef[5])+Col);
      WordBuf^[B2+B-1]:=ORD(W^.Def.FrameDef[4])+Col;
      FOR B2:=0 TO Y2-Y1-2 DO
       BEGIN
        WordBuf^[B*(B2+1)]:=ORD(W^.Def.FrameDef[6])+Col;
        WordBuf^[B*(B2+2)-1]:=ORD(W^.Def.FrameDef[6])+Col;
       END;
     END;
  END;
END; {WinFrame}

PROCEDURE RedrawScreen(X1,Y1,X2,Y2 : LONGINT);
{Redraw X1,Y1,X2,Y2 from the window-buffers. Assumes all windows saved to
  their buffers}

VAR
  I     :   LONGINT;

BEGIN
 FOR I:= Y1 TO Y2 DO UpdateScreen(X1,I,X2);
 Video.UpdateScreen(TRUE);
END;

PROCEDURE RedrawWin(W:WinType);
{Redraw a rectangle from the window-buffers. Assumes all windows saved to
  their buffers. Coordinates are the coordinates of Window W, but if Window
  W is below (parts of) other windows, the (parts of) other windows will be
  redrawn, not W.}

VAR
  I     :   LONGINT;

BEGIN
{$IFDEF Linux_Ansiwrap}
 Write(#27+'[=7l');
{$ENDIF}
 {No checks. Calling routine does check}
 WITH W^.Def DO
  FOR I:= Y1 TO Y2 DO UpdateScreen(X1,I,X2);
 {$IFDEF Linux_Ansiwrap}
 Write(#27+'[=7h');
{$ENDIF}
 Video.UpdateScreen(TRUE);
END;

PROCEDURE CombiRedraw(Xa1,Ya1,Xa2,Ya2,Xb1,Yb1,Xb2,Yb2 : LONGINT);
{Redraw both windows (A coordinates and B coordinates),
 but write a possible union only once.}

VAR Y : LONGINT;

BEGIN
  RedrawScreen(Xa1,Ya1,Xa2,Ya2);   { Write window A}
  {$IFDEF Linux_Ansiwrap}
   Write(#27+'[=7l');
  {$ENDIF}
  FOR Y:=Yb1 TO Yb2 DO
   BEGIN
    IF (Y>=Ya1) AND (Y<=Ya2) THEN  { WindowB and WindowA on same line?}
     BEGIN
      IF Xb1<Xa1 THEN              { at least Left overlap}
       BEGIN
        IF Xb2>Xa2 THEN            { left and right overlap}
         BEGIN
          UpdateScreen(Xb1,Y,Xa1);
          UpdateScreen(Xa2,Y,Xb2);
         END
        ELSE
         BEGIN
          IF Xb2>Xa1 THEN
           UpdateScreen(Xb1,Y,Xa1) { Left overlap only}
          ELSE
           UpdateScreen(Xb1,Y,Xb2);{ No overlap, winb lies entirely to left}
         END;
       END
      ELSE
       BEGIN
        IF Xb1<Xa2 THEN            { Possible right overlap}
          BEGIN
           IF Xb2>Xa2 THEN         { Right overlap}
            UpdateScreen(Xa2,Y,Xb2)
                                   { No else clause, if Winb entirely
                                    inside wina, then no rewrite}
          END
         ELSE
          UpdateScreen(Xb1,Y,Xb2)  { No overlap, window entirely to right}
       END
      END
     ELSE
      UpdateScreen(Xb1,Y,Xb2)      { Not on same Y line}
     END;
 {$IFDEF Linux_Ansiwrap}
  Write(#27+'[=7h');
 {$ENDIF}
 Video.UpdateScreen(TRUE);
END;

{ --------------------------------------------------------------------------
   Important internal routines
  -------------------------------------------------------------------------- }

FUNCTION GetTop:WinType;
{Gets window which is most 'on top', and not hidden}

VAR Cur : WinType;
    Cur2 : WinType;

BEGIN
 IF WindowList = NIL THEN
  GetTop:=NIL
 ELSE
  BEGIN
   Cur:=WindowList;                     { Search TOP window }
   Cur2:=NIL;
   WHILE (Cur^.Next <> NIL) DO
    BEGIN
      {$IFDEF WindowCheck}
     IF Cur^.Ident<>$13579BDF THEN            { Detect corruption}
      WinError(BadIdent);
      {$ENDIF}
     IF (NOT Cur^.Hidden) AND (Cur<>NIL) THEN
      Cur2:=Cur;
     Cur:=Cur^.Next;
    END;
   IF (Cur^.Hidden) THEN
    IF Cur2=NIL THEN
     GetTop:=NIL
    ELSE
     GetTop:=Cur2
    ELSE
   GetTop:=Cur;
  END
END;

PROCEDURE RemoveFromTree(W:WinType);
{Remove window W from the Window-tree  (=WindowList).
  Simplifies routines as WinClose a lot.}

VAR Cur : WinType;

BEGIN
 {$IFDEF WindowCheck}
  CheckWin(W);
 {$ENDIF}
 IF W = WindowList THEN
  Windowlist:=NIL
 ELSE
  BEGIN
   Cur:=WindowList;
   WHILE Cur <> NIL DO
    BEGIN
     IF Cur^.Next=W THEN
      BEGIN
       Cur^.Next:=W^.Next;
       Cur:=NIL
       END
      ELSE
       Cur:=Cur^.Next;
    END; {While}
  END; {Else}
END; {RemoveFromTree}

PROCEDURE PutBack(W:WinType);
{ Fix some things with respect to the current window. }

BEGIN
IF (W<>NIL) AND NOT W^.Hidden THEN
  BEGIN
   WITH W^ DO
    BEGIN
     Window(Xi1,Yi1,Xi2,Yi2);
     GotoXY(CurX,CurY);
     {$IFDEF Linux}
      ottycolor(ORD(Def.BackGround) shl 4+ORD(Def.ForeGround)); {Faster}
     {$ELSE}
      TextColor(ORD(Def.ForeGround)); TextBackGround(ORD(Def.BackGround));
      SetCursorSize(CursorState);
     {$ENDIF}
    END;
   END;
END; {PutBack}

PROCEDURE InSetTitle(W:WinType;Title:PChar);
{ Assumes saved windows. If framewindow, then set title "Title" centered
  in toprow of window IN BUFFER-MEMORY, caller has to update the screen!}

VAR
    A,B,
    Start : INTEGER;
    XDiff : INTEGER;
    Col : INTEGER;

BEGIN
   Col:=ORD(W^.Def.FrameFore)+16*ORD(W^.Def.FrameBack);
   A:=StrLen(Title);
   XDiff:=W^.Def.X2-W^.Def.X1+1;
   B:=A;
   FillWord(W^.Buffer^[2],XDiff-2,ORD(W^.def.FrameDef[5])+Col SHL 8);
   IF A>=XDiff THEN
    BEGIN
     B:=XDiff;
     Start:=0;
    END
   ELSE
    Start:=(XDiff-A) shr 1;
   FOR A:=0 TO B-1 DO
    BEGIN
     XDiff:=(Start+A) SHL 1;
     W^.Buffer^[XDiff]:=BYTE(Title[A]);
     W^.Buffer^[XDiff+1]:=BYTE(Col);
    END;
END;

    
{ --------------------------------------------------------------------------
  The fundamental exported routines. Open,Close,Clear,SetTitle and Use.
  -------------------------------------------------------------------------- }

{Put a title centered on the top of the window's frame}
PROCEDURE SetTitle(W:WinType;Title:PChar);

VAR Top : WinType;

BEGIN
 {$IFDEF WindowCheck}
  CheckWin(W);
 {$ENDIF}
 IF W^.Def.FrameOn THEN
  BEGIN
   Top:=GetTop;
   IF Top<>NIL THEN WinWindowToBuf(Top); { Save Top window to memory
                                           for redraw}
   IF W^.Title <> NIL THEN
    StrDispose(W^.Title);
   InSetTitle(W,Title);
   
   W^.Title:=StrNew(Title);
   RedrawScreen(W^.Def.X1,W^.Def.Y1,W^.Def.X2,W^.Def.Y1);
   PutBack(GetTop);
  END;
END; {SetTitle}

{Clear Window W, with current attributes and GotoXY(1,1).
 Works in buffer-memory, and calls redrawsceen afterwards}
PROCEDURE Clear(W:WinType);

VAR Top          : WinType;
    YDiff,A,XDiff,Col   : INTEGER;

BEGIN
 {$IFDEF WindowCheck}
  CheckWin(W);
 {$ENDIF}
 Top:=GetTop;             {Save it's contents}
 IF (Top <>NIL) AND (Top<>W) THEN WinWindowToBuf(Top);

 {All Windows saved, poke around in buffer, and redraw}

 XDiff:=W^.Xi2-W^.Xi1+1;
 YDiff:=W^.Yi2-W^.Yi1+1;
 Col:=32+(ORD(W^.Def.ForeGround)+ ORD(W^.Def.BackGround) SHL 4) SHL 8;
 IF W^.Def.FrameOn THEN
   FOR A:=1 TO YDiff DO
     FillWord(W^.Buffer^[2*(1+(XDiff+2)*A)],XDiff,Col)
  ELSE
    FillWord(W^.Buffer^[0],YDiff*XDiff,Col);
 W^.CurX:=1;
 W^.CurY:=1;
 RedrawWin(W);
 PutBack(GetTop);
END;

VAR InitFull : BOOLEAN; { Used to avoid a ClrScr when opening FullScreen}

{Opens a window, defined by "WD", new window will be top window.}
FUNCTION WinOpen(WD : WinDef):WinType;

VAR Cur : WinType;
    FO  : INTEGER;
    Col : WORD;

BEGIN
 Cur:=GetTop;
 IF Cur<>NIL THEN WinWindowToBuf(Cur); { Save Top window to memory
                                          Cause new topwindow will be created}

 { Create new handle on Top}

 IF WindowList=NIL THEN
  BEGIN
    NEW(WindowList);
    Cur:=WindowList;
   END
 ELSE
  BEGIN
   Cur:=WindowList;
   WHILE (Cur^.Next<> NIL) DO Cur:=Cur^.Next;
   NEW(Cur^.Next);
   Cur:=Cur^.Next;
  END;
 Cur^.Next:=NIL;

 { Set up the Window-record}
 {$IFDEF WindowCheck}
   CheckWinDef(WD);
 {$ENDIF}

 Cur^.Def:=WD;
 FO:=0;
 IF WD.FrameOn THEN
  FO:=1;
 Cur^.Xi1:=WD.X1+FO;            { Set up writable window coordinates}
 Cur^.Xi2:=WD.X2-FO;
 Cur^.Yi1:=WD.Y1+FO;
 Cur^.Yi2:=WD.Y2-FO;
 Cur^.Hidden:=False;
 Cur^.Title:=NIL;
 Cur^.CursorState:=$090A;
 Cur^.Ident:=$13579BDF;

WITH WD DO
 FO:=(X2-X1+1)*(Y2-Y1+1)*2*Multiplyer; { Size of Window }

GetMem(Cur^.Buffer, FO+Spare); { Allocate space}

{Initfull is a backdoor to open a window without clearing it. It's used to
set up FullScreen. The next time that a major window operation (opening of
a window) is performed, the FullScreen will be saved (under Dos/BP)}

 WITH WD DO
  BEGIN
   Col:=32+(ORD(ForeGround)+ (ORD(BackGround) SHL 4)) SHL 8;
   FO:=(X2-X1+1)*(Y2-Y1+1);
  END;
 IF NOT (InitFull) THEN
  BEGIN
   FillWord(Cur^.Buffer^[0],FO,Col);        {Clear buffer in the right color}
   WinFrame(Cur);                           {create a frame if necessary}
   RedrawWin(Cur);                          {Window to screen}
   Cur^.CurX:=1; Cur^.CurY:=1;              {Set up cursor coordinates.}
   PutBack(Cur);                            {Activate some small stuf}
  END;

 WinOpen:=Cur;                              {Return value}
END; {WinOpen}

PROCEDURE Use(W:WinType);
{Switch to window W, safe the other window.
 Do not perform a switch when Top is already W. (to avoid unnecessary
  rewriting)}

VAR Top: WinType;

BEGIN
 {$IFDEF WindowCheck}
  CheckWin(W);
 {$ENDIF}
 IF W <> NIL THEN
  BEGIN
   Top:=GetTop;
   IF Top <> NIL THEN
    BEGIN
     IF WindowList=W THEN
       WindowList:=W^.Next;
     IF Top <>W THEN
      BEGIN
       WinWindowToBuf(Top);       { Save it's contents }
       RemoveFromTree(W);
       Top^.Next:=W;
       W^.Next:=NIL;

       RedrawWin(W);
       PutBack(GetTop)

      END; { TOP<>W}
     PutBack(W);
    END;
  END;
END;

PROCEDURE WinClose(VAR W:WinType);
{Close window, deallocate all memory, and such stuff}

VAR FO              : INTEGER;
    Cur,Cur2,Cur3   : WinType;
    OX1,OX2,OY1,OY2 : LONGINT;

BEGIN
 {$IFDEF WindowCheck}
   CheckWin(W);
 {$ENDIF}

 Cur:=GetTop;
 IF Cur<>NIL THEN WinWindowToBuf(Cur); { Save Top window to memory
                                          Cause the screen will be rewritten from
                                          scratch }

 IF (W <> NIL) AND (WindowList<>NIL) THEN
  BEGIN
   WITH W^.Def DO
    FO:=(X2-X1+1)*(Y2-Y1+1)*2*multiplyer+Spare ;
   { Width of Window }
  Cur:=WindowList;
  Cur2 := Cur;
  WHILE (Cur2<>NIL) DO
   BEGIN
    Cur3 := Cur2^.Next;
    IF (Cur2 = W) THEN
     BEGIN
      Cur^.Next := Cur3;
      IF Cur2^.Title <> NIL THEN
       StrDispose (Cur2^.Title);
      OX1:=Cur2^.def.X1;       OX2:=Cur2^.def.X2;
      OY1:=Cur2^.def.Y1;       OY2:=Cur2^.def.Y2;
      FreeMem(W^.Buffer, FO); { DeAllocate space }
      DISPOSE(Cur2);
     END
    ELSE
      Cur := Cur2;
    Cur2 := Cur3;
   END;
   W:=NIL;
  RedrawScreen(OX1,OY1,OX2,OY2);
  END;
  PutBack(GetTop);
END;

{ --------------------------------------------------------------------------
   Changing Window parameters ((un)hiding,move,change dimensions and clone)
  -------------------------------------------------------------------------- }


PROCEDURE Hide(W:WinType);
{Hide window W}

VAR
    Cur,Top : WinType;

BEGIN
 {$IFDEF WindowCheck}
  CheckWin(W);
 {$ENDIF}

 Top:=GetTop;
 IF Top<>NIL THEN WinWindowToBuf(Top); { Save Top window to memory
                                         because the screen might be rewritten
                                         from scratch }
 W^.Hidden:=TRUE;                      {Actual hide}
 IF (Top=W) THEN                       {Make sure top is not hidden}
  BEGIN
  IF  (WindowList^.Next<>NIL) THEN
   BEGIN
    Cur:=WindowList;
    WHILE Cur^.Next^.Next=NIL DO Cur:=Cur^.Next;
     Cur^.Next:=NIL;
    Top^.Next:=WindowList;
    WindowList:=Top;
    END
  END;
  RedrawWin(W);
  PutBack(GetTop);
END;

PROCEDURE UnHide(W:WinType);
{Unhide an hidden window}

VAR
    Top : WinType;

BEGIN
 {$IFDEF WindowCheck}
  CheckWin(W);
 {$ENDIF}

 Top:=GetTop;
 IF Top<>NIL THEN WinWindowToBuf(Top); { Save Top window to memory
                                          Cause the screen will be rewritten from
                                          scratch }
  W^.Hidden:=FALSE;
  RedrawWin(W);
  PutBack(Top);
END;

{ Change dimensions and/or position of window}
PROCEDURE Change(W: WinType; OX1,OY1,OX2,OY2: AbsCoord);

VAR Buf    : BufPtr;
    Top    : WinType;
    XDiff,
    XDiff2,
    YDiff,
    YDiff2,
    DoX,
    DoY,A  : WORD;
    Col    : WORD;
    XX1,YY1,XX2,YY2 : LONGINT;

BEGIN
 {$IFDEF WindowCheck}
  CheckWin(W);
 { IF OY1>OY2 THEN
   WinError(YTooBig);
  IF OX1>OX2 THEN
   WinError(XTooBig);
  IF (OY1=OY2) AND W^.Def.FrameOn THEN
   WinError(YTooBig);
  IF (OX1=OX2) AND W^.Def.FrameOn THEN
   WinError(XTooBig);
  IF OY2>}
 {$ENDIF}

 Top:=GetTop;
 IF Top<>NIL THEN WinWindowToBuf(Top); { Save Top window to memory because the
                                          window will be rewritten from
                                          scratch}
 XX1:=W^.Def.X1;                       { Save old coordinates. To ease checking}
 YY1:=W^.Def.Y1;                       { and because we need to redraw the old}
 XX2:=W^.Def.X2;                       { coordinates}
 YY2:=W^.Def.Y2;
 WITH W^.Def DO            {Update WinDef}
  BEGIN
   X1:=OX1; X2:=OX2;
   Y1:=OY1; Y2:=OY2;
  END;
 {$IFDEF WindowCheck}
  CheckWinDef(W^.Def);
 {$ENDIF}

 YDiff:=OY2-OY1+1;
 YDiff2:=YY2-YY1+1;
 XDiff:=OX2-OX1+1;
 XDiff2:=XX2-XX1+1;
 A:=YDiff*XDiff*2*multiplyer+Spare;

 GetMem(Buf,A);                     {Allocate the new resized buffer}
 Col:=32+(ORD(W^.Def.ForeGround)+ ORD(W^.Def.BackGround) SHL 4) SHL 8;
 FillWord(Buf^,(A-Spare) SHR 1,Col);
 DoY:=YDiff;
 IF YDiff>YDiff2 THEN          { Select the Nr of Lines to copy}
  DoY:=YDiff2;
 DoX:=XDiff;
 IF XDiff>XDiff2 THEN          { Select the Nr of Columns to copy}
  DoX:=XDiff2;

 FOR A :=0 TO DoY-1 DO
  Move (W^.Buffer^[2*A*XDiff2],Buf^[2*A*XDiff],2*DoX);

 A:=YDiff2*XDiff2*2*multiplyer+Spare;
 Freemem(W^.Buffer,A);
 W^.Buffer:=Buf;
 A:=0;
 IF W^.Def.FrameOn THEN
   A:=1;

 {Calculate writable coordinates}

 W^.Xi1:=W^.Def.X1+A;
 W^.Xi2:=W^.Def.X2-A;
 W^.Yi1:=W^.Def.Y1+A;
 W^.Yi2:=W^.Def.Y2-A;

 {Normalize cursorpositions}

 IF W^.CurX> (W^.Xi2-W^.Xi1) THEN W^.CurX:=(W^.Xi2-W^.Xi1);
 IF W^.CurY> (W^.Yi2-W^.Yi1) THEN W^.CurY:=(W^.Yi2-W^.Yi1);
 IF W^.Def.FrameOn THEN
  BEGIN

   {Draw new frame in Buffer in memory}

   WinFrame(W);
  END;

 {Reconstruct title}

 IF W^.Title<>NIL THEN
  InSetTitle(W,W^.Title);
 WITH W^.Def DO
  CombiRedraw(XX1,YY1,XX2,YY2,X1,Y1,X2,Y2);
 PutBack(GetTop);
END; {Change}

{Move window around without changes to window dimensions,
  probably A LOT faster than Change}
PROCEDURE WinMove(W: WinType;OX1,OY1: AbsCoord);

VAR    Top     : WinType;
       A       : INTEGER;
       XX1,YY1,
       XX2,YY2 : LONGINT;


BEGIN
 {$IFDEF WindowCheck}
  CheckWin(W);
 {$ENDIF}

 Top:=GetTop;
 IF Top<>NIL THEN WinWindowToBuf(Top); { Save Top window to memory
                                          Cause the screen will be rewritten from
                                          scratch }

 XX1:=W^.Def.X1;  YY1:=W^.Def.Y1;      {Save some values for redraw procedure}
 XX2:=W^.Def.X2;  YY2:=W^.Def.Y2;
 WITH W^.Def DO                        {Calc new coords}
  BEGIN
   X2:=X2-X1+OX1;
   Y2:=Y2-Y1+OY1;
   X1:=OX1;
   Y1:=OY1;
   {Calculate writable coordinates}
   A:=0; IF FrameOn THEN A:=1;
   W^.Xi1:=X1+A;
   W^.Xi2:=X2-A;
   W^.Yi1:=Y1+A;
   W^.Yi2:=Y2-A;
  END;
 WITH W^.Def DO
  CombiRedraw(XX1,YY1,XX2,YY2,X1,Y1,X2,Y2);
 PutBack(GetTop);
END; {WinMove}

{Clone a window, make the clone hidden}
FUNCTION WinClone(W:WinType):WinType;

VAR Top,
    NewW : WinType;
    FO   : INTEGER;


BEGIN
 {$IFDEF WindowCheck}
  CheckWin(W);
 {$ENDIF}

 Top:=GetTop;
 IF Top<>NIL THEN WinWindowToBuf(Top); { Save Top window to memory
                                          Cause the screen will be rewritten from
                                          scratch }
 NEW(NewW);
 Move(W^,NewW^,SIZEOF(WinDataRec));
 NewW^.Buffer:=NIL;
 NewW^.Title:=NIL;
 NewW^.Def.FrameDef:='';
 WITH NewW^.Def DO
  FO:=(X2-X1+1)*(Y2-Y1+1)*2*Multiplyer+Spare ; { Width of Window }

 GetMem(NewW^.Buffer, FO);                     { Allocate New buffer}

 Move(W^.Buffer^,NewW^.Buffer^,FO);              { Copy Buffer}

 IF W^.Title<>NIL THEN
  NewW^.Title:=StrNew(W^.Title);

 NewW^.Def.FrameDef:=W^.Def.FrameDef;  { Copy frame}

 NewW^.Next:=WindowList;                          { Put in list}
 WindowList:=NewW;

 NewW^.Hidden:=TRUE;
{ RedrawScreen;}      { Not necessary since new window is hidden}
 PutBack(GetTop);
 WinClone:=NewW;
END; {Clone}

{ --------------------------------------------------------------------------
   Writing to windows.
  -------------------------------------------------------------------------- }

{Write string "towrite" to current window, wrap if possible}
PROCEDURE WrapWrite(CONST Towrite:String);
{Write string to current Window, and wrap the text.
 Not the most brilliant procedures, but it works quite good, for the
 5 minutes I spent on it. }

VAR X,Width : LONGINT;
    Cp      : LONGINT;
    InS     : String;
    Ok      : BOOLEAN;
    Top     : WinType;

BEGIN
 Top:=GetTop;
 IF Top= NIL THEN               {Rare, people will have to close FullScreen,}
  EXIT;                             {but you never know.}
 InS:=Towrite;
 Width:=Top^.Xi2-Top^.Xi1+2;    {Width of writable area +1}
 OK:=FALSE;
 REPEAT
  X:=WhereX;                    { x-coordinate}
  Cp:=Length(InS);              { bytes to write}
  IF (X+Cp)<Width THEN          { Can I write without wrapping}
   BEGIN                        { Then exit}
    Ok:=TRUE;
    Write(Ins);
   END
  ELSE
   BEGIN
    Cp:=Pos(' ',Ins);           { Find next space}
    IF Cp=0 THEN
     BEGIN
      Cp:=Length(Ins);          {Not found}
      IF (Cp<Width) AND ((X+Cp)>=Width) THEN {Can I get the rest on the next}
       Writeln;                              {line? Then insert a lf}
      IF Cp>0 THEN
       BEGIN
        write(Copy(Ins,1,Cp));
        Delete (Ins,1,Cp);
       END;
      Ok:=TRUE;
     END
    ELSE
     BEGIN
      Dec(Cp);
      IF (Cp<Width) AND ((X+Cp)>=Width) THEN
       BEGIN
        Writeln;
       END;
      IF (Cp+X)<>Width THEN
       INC(Cp);
      IF Cp>0 THEN
       BEGIN
        write(Copy(Ins,1,Cp));
        Delete (Ins,1,Cp);
       END
      ELSE
       Ok:=TRUE;
     END;
    END;
 UNTIL Ok;
END;

{Write string "towrite" to current window, wrap if possible, append linefeed}
PROCEDURE WrapWriteln(CONST Towrite:String);

BEGIN
 WrapWrite(Towrite);
 Writeln;
END;


{ --------------------------------------------------------------------------
    (re)initialisation of unit, opening of fullscreen.
  -------------------------------------------------------------------------- }


PROCEDURE InitFullScreen;
{Init code procedure. Set up the fullscreen, init all it's values
( cursor, colors etc) to the console values}

VAR FullDef : WinDef;

BEGIN
 FullDef.X1:=1;
 FullDef.X2:=Width;
 FullDef.Y1:=1;
 FullDef.Y2:=Height;

 FullDef.FrameOn:=FALSE;
 FullDef.BackGround:=(textattr AND 240) SHR 4;
 FullDef.ForeGround:=textattr AND 15;
          { A detection with a DOS-interupt write could be better}
 InitFull:=TRUE;
 FullScreen:=WinOpen(FullDef);
 WITH FullScreen^ DO
  BEGIN
   CurX:=WhereX;  CurY:=WhereY; (* Save initial cursorpositions *)
   {$IfDef Linux}
    FillWord(FullScreen^.Buffer^[0],(Def.X2-Def.X1+1)*(Def.Y2-Def.Y1+1),32);
   {$ENDIF}
 END;
 InitFull:=FALSE;
  WITH FullScreen^ DO
  BEGIN
   Window(Def.X1,Def.Y1,Def.X2,Def.Y2);
   GotoXY(CurX,CurY);
  END;
END;


PROCEDURE CrtInit;  { When more advanced, it could be exported to be
                      called to reset module. Should check on active windows
                      first (WindowList=NIL back to initcode. If Crt will
                      implement a reset-procedure in the future, it should
                      also call Crt-reinit}

VAR A : WORD;

BEGIN
 {$IFDEF LINUX}
  {$IFDEF OldLinuxWin}
   Height:=25;           { Old Linux Crt doesn't allow other sizes}
   Width :=80;
  {$ELSE}                { new (>mid october) snapshots do}
   Height:=Screenheight;
   Width :=ScreenWidth;
   FillWord(ConsoleBuf^[0],screenheight*ScreenWidth,32); {Patch for early
                                  version of new type Crt.}

  {$ENDIF}
  write (#27+'(K');     {Used to switch to the IBM charset under Linux}
  ClrScr;               { I can't get the startup screen under Linux yet, so
                             I clear it}
 {$ELSE}
  DosMemGet($40,$49,A,1);
  IF A=7 THEN
   ScreenSeg:=$B000
  ELSE
   ScreenSeg:=$B800;
  DosMemGet($40,$84,Height,1);
  inc(Height);                          {Bios-area contains Height-1}
  DosMemGet($40,$4a,Width,1);

  { A check for erraneous values should be programmed here, and a
      int 10H ah=$1b to get the correct values}

 {$ENDIF}
 {$IFDEF WindowCheck}        {Initialise the Errorhandler to the default}
   WinError:=InternalWinError;
 {$ENDIF}
 WindowList:=NIL;
 InitFullScreen;
END;

BEGIN
 InitVideo;
 CrtInit;
END.
