{
License:              LGPL, see the file COPYING.TXT, included in this
                      distribution for details about the copyright.
}
{ gives access to extended mem[] functions }

unit FarMem;

{$MODE OBJFPC}
interface

type

     tdosmemb = class
              procedure writemem(ofs : DWord; data : byte);
              function readmem(ofs : DWord) : byte;
              property memarray[ofs : DWord] : byte read readmem write writemem; default;
     end;

     tdosmemw = class
              procedure writemem(ofs : DWord; data : Word);
              function readmem(ofs : DWord) : Word;
              property memarray[ofs : DWord] : Word read readmem write writemem; default;
     end;

     tdosmeml = class
              procedure writemem(ofs : DWord; data : Longint);
              function readmem(ofs : DWord) : Longint;
              property memarray[ofs : DWord] : Longint read readmem write writemem; default;
     end;

     tfarmemb = class
              procedure writemem(s : Word; ofs : DWord; data : byte);
              function readmem(s : Word; ofs : DWord) : byte;
              property memarray[s : Word; ofs : DWord] : byte read readmem write writemem; default;
     end;

     tfarmemw = class
              procedure writemem(s : Word; ofs : DWord; data : word);
              function readmem(s : Word; ofs : DWord) : word;
              property memarray[s : Word; ofs : DWord] : word read readmem write writemem; default;
     end;

     tfarmeml = class
              procedure writemem(s : Word; ofs : DWord; data : longint);
              function readmem(s : Word; ofs : DWord) : longint;
              property memarray[s : Word; ofs : DWord] : longint read readmem write writemem; default;
     end;

var fmemb : tfarmemb;
    fmemw : tfarmemw;
    fmeml, fmemd : tfarmeml;
    
    dmemb : tdosmemb;
    dmemw : tdosmemw;
    dmeml, dmemd : tdosmeml;

implementation

procedure tdosmemb.writemem(ofs : DWord; data : Byte); assembler;
asm
   movb DATA, %al
   movl OFS, %edi
   movb %al, %fs:(%edi)
end ['EAX', 'EDI'];

function tdosmemb.readmem(ofs : DWord) : Byte; assembler;
asm
   movl OFS, %edi
   movb %fs:(%edi), %al
end ['EAX', 'EDI'];

procedure tdosmemw.writemem(ofs : DWord; data : Word); assembler;
asm
   movw DATA, %ax
   movl OFS, %edi
   movw %ax, %fs:(%edi)
end ['EAX', 'EDI'];

function tdosmemw.readmem(ofs : DWord) : Word; assembler;
asm
   movl OFS, %edi
   movw %fs:(%edi), %ax
end ['EAX', 'EDI'];

procedure tdosmeml.writemem(ofs : DWord; data : Longint); assembler;
asm
   movl DATA, %eax
   movl OFS, %edi
   movl %eax, %fs:(%edi)
end ['EAX', 'EDI'];

function tdosmeml.readmem(ofs : DWord) : Longint; assembler;
asm
   movl OFS, %edi
   movl %fs:(%edi), %eax
end ['EAX', 'EDI'];


procedure tfarmemb.writemem(s : Word; ofs : DWord; data : Byte); assembler;
asm
   movw   S, %bx
   movb   DATA, %al
   movl   OFS, %edi
   movw   %bx, %gs
   movb   %al, %gs:(%edi)
end ['EAX','EBX','EDI'];

function tfarmemb.readmem(s : Word; ofs : DWord) : Byte; assembler;
asm
   movw   S, %bx
   movl   OFS, %edi
   movw   %bx, %gs
   movb   %gs:(%edi), %al
end ['EAX','EBX','EDI'];

procedure tfarmemw.writemem(s : Word; ofs : DWord; data : Word); assembler;
asm
   movw   S, %bx
   movw   DATA, %ax
   movl   OFS, %edi
   movw   %bx, %gs
   movw   %ax, %gs:(%edi)
end ['EAX','EBX','EDI'];

function tfarmemw.readmem(s : Word; ofs : DWord) : Word; assembler;
asm
   movw   S, %bx
   movl   OFS, %edi
   movw   %bx, %gs
   movw   %gs:(%edi), %ax
end ['EAX','EBX','EDI'];

procedure tfarmeml.writemem(s : Word; ofs : DWord; data : Longint); assembler;
asm
   movw   S, %bx
   movl   DATA, %eax
   movl   OFS, %edi
   movw   %bx, %gs
   movl   %eax, %gs:(%edi)
end ['EAX','EBX','EDI'];

function tfarmeml.readmem(s : Word; ofs : DWord) : Longint; assembler;
asm
   movw   S, %bx
   movl   OFS, %edi
   movw   %bx, %gs
   movl   %gs:(%edi), %eax
end ['EAX','EBX','EDI'];

end.
{ 01-01-1999 start of history
  - added a {$ASMMODE DIRECT}
}
