{Codes for ELib.GetKey}



CONST
   NUL = $00;                     DLE = $10;
   SOH = $01;                     DC1 = $11;
   STX = $02;                     DC2 = $12;
   ETX = $03;                     DC3 = $13;
   EOT = $04;                     DC4 = $14;
   ENQ = $05;                     NAK = $15;
   ACK = $06;                     SYN = $16;
   BEL = $07;                     ETB = $17;
   BS  = $08;  (* Backspace *)    CAN = $18;
   HT  = $09;  (* Tab *)          EM  = $19;
   LF  = $0A;  (* Ctrl_Enter *)   SUB = $1A;
   VT  = $0B;                     ESC = $1B;
   FF  = $0C;                     FS  = $1C;
   CR  = $0D;  (* Enter *)        GS  = $1D;
   SO  = $0E;                     RS  = $1E;
   SI  = $0F;                     US  = $1F;

   Space = $20;   Tilde = $7E;
   DEL   = $7F;   (* Ctrl_Backspace *)

   CtrlA = $01;    CtrlH = $08;    CtrlO = $0F;    CtrlU = $15;
   CtrlB = $02;    CtrlI = $09;    CtrlP = $10;    CtrlV = $16;
   CtrlC = $03;    CtrlJ = $0A;    CtrlQ = $11;    CtrlW = $17;
   CtrlD = $04;    CtrlK = $0B;    CtrlR = $12;    CtrlX = $18;
   CtrlE = $05;    CtrlL = $0C;    CtrlS = $13;    CtrlY = $19;
   CtrlF = $06;    CtrlM = $0D;    CtrlT = $14;    CtrlZ = $1A;
   CtrlG = $07;    CtrlN = $0E;

   (* Functie & Alt-key combinaties : (samengestelde combinaties) *)
   Alt1 = $7800;   AltQ = $1000;   AltA = $1E00;   AltZ = $2C00;
   Alt2 = $7900;   AltW = $1100;   AltS = $1F00;   AltX = $2D00;
   Alt3 = $7A00;   AltE = $1200;   AltD = $2000;   AltC = $2E00;
   Alt4 = $7B00;   AltR = $1300;   AltF = $2100;   AltV = $2F00;
   Alt5 = $7C00;   AltT = $1400;   AltG = $2200;   AltB = $3000;
   Alt6 = $7D00;   AltY = $1500;   AltH = $2300;   AltN = $3100;
   Alt7 = $7E00;   AltU = $1600;   AltJ = $2400;   AltM = $3200;
   Alt8 = $7F00;   AltI = $1700;   AltK = $2500;
   Alt9 = $8000;   AltO = $1800;   AltL = $2600;
   Alt0 = $8100;   AltP = $1900;

   F1  = $3B00;   ShiftF1  = $5400;   CtrlF1  = $5E00;   AltF1  = $6800;
   F2  = $3C00;   ShiftF2  = $5500;   CtrlF2  = $5F00;   AltF2  = $6900;
   F3  = $3D00;   ShiftF3  = $5600;   CtrlF3  = $6000;   AltF3  = $6A00;
   F4  = $3E00;   ShiftF4  = $5700;   CtrlF4  = $6100;   AltF4  = $6B00;
   F5  = $3F00;   ShiftF5  = $5800;   CtrlF5  = $6200;   AltF5  = $6C00;
   F6  = $4000;   ShiftF6  = $5900;   CtrlF6  = $6300;   AltF6  = $6D00;
   F7  = $4100;   ShiftF7  = $5A00;   CtrlF7  = $6400;   AltF7  = $6E00;
   F8  = $4200;   ShiftF8  = $5B00;   CtrlF8  = $6500;   AltF8  = $6F00;
   F9  = $4300;   ShiftF9  = $5C00;   CtrlF9  = $6600;   AltF9  = $7000;
   F10 = $4400;   ShiftF10 = $5D00;   CtrlF10 = $6700;   AltF10 = $7100;
   F11 = $8500;   ShiftF11 = $8700;   CtrlF11 = $8900;   AltF11 = $8B00;
   F12 = $8600;   ShiftF12 = $8800;   CtrlF12 = $8A00;   AltF12 = $8C00;

   Home   = $04700;   CtrlHome   = $07700;   AltHome   = $09700;
   ArrU   = $04800;   CtrlArrU   = $08D00;   AltArrU   = $09800;
   PgUp   = $04900;   CtrlPgUp   = $08400;   AltPgUp   = $09900;
   ArrL   = $04B00;   CtrlArrL   = $07300;   AltArrL   = $09B00;
   ArrR   = $04D00;   CtrlArrR   = $07400;   AltArrR   = $09D00;
   KEnd   = $04F00;   CtrlEnd    = $07500;   AltEnd    = $09F00;
   ArrD   = $05000;   CtrlArrD   = $09100;   AltArrD   = $0A000;
   PgDn   = $05100;   CtrlPgDn   = $07600;   AltPgDn   = $0A100;
   KInsert= $05200;   CtrlInsert = $09200;   AltInsert = $0A200;
   KDelete= $05300;   CtrlDelete = $09300;   AltDelete = $0A300;

   AltEsc          = $0100;  AltBackSlash  = $2B00;  CtrlNumMinus   = $08E00;
   AltBackSpace    = $0E00;  AltKomma      = $3300;  CtrlNum5       = $08F00;
   ShiftTab        = $0F00;  AltDot        = $3400;  CtrlNumPlus    = $09000;
   AltOpenBracket  = $1A00;  AltSlash      = $3500;  CtrlTab        = $09400;
   AltCloseBracket = $1B00;  AltNumAsterix = $3700;  CtrlNumSlash   = $09500;
   AltEnter        = $1C00;  AltNumMinus   = $4A00;  CtrlNumAsterix = $09600;
   AltSemicolon    = $2700;  AltNumPlus    = $4E00;  AltNumSlash    = $0A400;
   AltQuote        = $2800;  AltMinus      = $8200;  AltTab         = $0A500;
   AltBackQuote    = $2900;  AltEqual      = $8300;  AltNumEnter    = $0A600;
