{ example for : registers record
                rm_Addr record
                DOS memory access
                dpmi_allocate_DOS_memory_block()
                dpmi_free_DOS_memory_block()
                dpmi_get_rm_interrupt()
                dpmi_call_rm_procedure_with_iret_frame()
                seg_memcpy()

This demo (C) 1998 by Thomas Schatzl

Author:               Alexander Stohr AlexS@Freepage.de, kind of contributed
                      to the TOM32 package.
License               LGPL, see the file docs/COPYING.TXT, included in
                      this distribution for details about the copyright.
Description           Calls 16 bit code from protected mode.

  Does this by issueing an Int 21h by directly calling it with the following
  parameters:

  %ah = $09 - print string terminated with a '$' character
  %ds:%dx = real mode segment:offset pointer of string to print
}

program Call16;

uses
    dpmi, memory;

    { the '$' terminated string we want to print. The #13#10 at the end of the
      string positions the cursor at the next line }
const str = 'We are in 16 bit code.'+#$0d+#$0a+'$';

var
   reg16 : Registers;   { registers structure }
   rm_Int21 : rm_Addr;  { used to obtain the real mode address of interrupt $21 }
   rm_Mem   : rm_Addr;  { start of real mode memory buffer we need }
   rm_Mem_Selector : Word; { the selector to this real mode memory buffer }
  
begin
     { allocate a DOS memory are to store string into }
     dpmi_allocate_DOS_memory_block(Length(str), rm_Mem, rm_Mem_Selector);

     { copy string into real mode memory buffer previously allocated. Btw,
       we could have used the internal transfer buffer too and saving us some
       instructions. }
     seg_memcpy(dseg, dword(@str)+1, rm_Mem_Selector, 0, length(str));

     { get %cs:%ip real mode address of int 21h which we call later }
     dpmi_get_rm_interrupt($21,RM_Int21);
     { store the address we got into %cs:%ip fields of registers record }
     Reg16.CS := RM_Int21.Segment;
     Reg16.IP := RM_Int21.Offset;

     { insert parameters into registers structure }
     Reg16.ah := $09;            { print $ terminated text }
     Reg16.ds := rm_Mem.Segment;
     Reg16.dx := rm_Mem.Offset;

     { call the real mode procedure which returns with an iret (interrupts
       always return with an iret instruction opposed to far returns of simple
       procedures) at %cs:%ip fields of the supplied registers structure }
     dpmi_call_rm_procedure_with_iret_frame(Reg16);

     { free DOS memory block after we've used it }
     dpmi_free_DOS_memory_block(RM_Mem_Selector);
end.

