{Demonstrates CPU unit.

This demo (C) 1998 by Thomas Schatzl

Author:               Thomas Schatzl
License               LGPL, see the file docs/COPYING.TXT, included in
                      this distribution for details about the copyright.
Description           Shows some CPU info obtained by the CPU unit.
                      Additionally it shows the accuracy of the CPU timing
                      units. Times the crt units delay() procedure.

}
program cputest;

uses cpu,
     crt; { delay() }

var z,
    z2 : pztimer;

begin
     { this_cpu is automatically filled with the current CPU info at startup }
     with this_cpu do begin
          Writeln('CPU id       : ', cpu_id);
          Writeln('CPU family id: ', get_family_string(family));
          Writeln('CPU family   : ', family);
          Writeln('CPU model    : ', model);
          Writeln('CPU stepping : ', stepping);
          Writeln('CPU manuf.   : ', get_mfc_string(manufacturer));
          Writeln('CPU clock    : ', clock_rate);
          Writeln('CPU rating   : ', rating);
          Writeln;
          Writeln('CPU capabilities');
          Writeln('FPU    : ', cpu_supported(cHAVE_FPU));
          Writeln('CPUid  : ', cpu_supported(chave_cpuid));
          Writeln('RDTSC  : ', cpu_supported(chave_rdtsc));
          Writeln('MMX    : ', cpu_supported(chave_MMX));
          Writeln('eMMX   : ', cpu_supported(chave_eMMX));
          Writeln('3Dnow! : ', cpu_supported(chave_3dnow));
          Writeln('KNI    : ', cpu_supported(chave_KNI));
          Writeln;
     end;

     { Initializes the two timing objects used by this programs }
     new(z,init);
     new(z2, init);

     { Time the crt delay() procedure }
     Writeln('Timing crt delay() procedure ...');
     { start timer }
     z^.start;
     { the 1 second delay is measured }
     delay(1000);
     { stop timer }
     z^.stop;
     { write timing count }
     writeln('The crt delay() lasted for ', round(z^.count), ' microseconds.');

     { reset both timers }
     z^.reset;
     z2^.reset;
     Writeln('Timing ztimer delay...');

     { start second timer }
     z2^.start;
     { issue a highly accurate 1 second delay }
     z^.delay(round(1 / z^.resolution));
     { stop second timer }
     z2^.stop;

     { show how long the first timer measured }
     Writeln('zTimer counted up to ', round(z^.count));
     { show the measured timed delay  }
     Writeln('zTimer delay lasted for ', round(z2^.count), ' microseconds.');

     dispose(z2, done);
     dispose(z,done);
end.
