{
This demo (C) 1999 by Thomas Schatzl

Author:               Thomas Schatzl.
License               LGPL, see the file docs/COPYING.TXT, included in
                      this distribution for details about the copyright.
Description           Shows aspects of the generic error handling unit

  Shows how to install an error handler for a small demo application.

}

program handler;

{$mode delphi}
uses crt, { delay(), readkey() }
     errhndle;

var ch : char;  { just a temporary variable holding the character of the last
                  keypress }
    this_programs_id : error_id; { this programs error id number }

{ the apps own error handler }
function handler_callback(n : error_number) : error_msg;
var tmp : error_msg;
begin
     { force the error unit to terminate the program after writing the error
       to stderr }
     tmp.flags := err_flag_terminate;
     { translates the internal error number n to another }
     tmp.number := 20;
     { the description of the error }
     tmp.description := 'You pressed the invalid key '''+ch+'''';
     result := tmp;
end;


begin
     { create a new handler id }
     createhandler('HANDLER', this_programs_id);
     { set the handler procedure }
     sethandler(this_programs_id, handler_callback);


     { our demo application }
     Writeln('Hit any number key or return to exit without errors');
     Writeln;
     ch := readkey;
     case ch of
          '1'..'9', #13 : Writeln('Preparing to continue');
          else error_handler(this_programs_id, $FFFF);
     end;
     Writeln;
     Writeln('Doing some other very important stuff');
     delay(1000); { ;) }
     Writeln;
     Writeln('Finished without problems');
end.
