{ example for :
          dpmi_set_pm_interrupt()
          dpmi_get_pm_interrupt()
          Interrupt redirection
          Software interrupt
          registers record
          cseg()

This demo (C) 1998 by Thomas Schatzl

Author:               Thomas Schatzl
License               LGPL, see the file docs/COPYING.TXT, included in
                      this distribution for details about the copyright.
Description           This example shows how to redirect a software
                      interrupt by changing the protected mode handler
                      of the DPMI host.

  In more detail it hooks interrupt 1Ch which is called every time the timer
  interrupt (int 08) is executed. This is the preferred way to hook the timer,
  because int 1Ch is a software interrupt which doesn't need so much
  initialization stuff compared to hooking a hardware interrupt.
}

{$OUTPUT_FORMAT AS}
{$ASMMODE DIRECT}

uses crt, { wherey(), keypressed() }
     dpmi;

const int1c = $1c; { interrupt number we want to hook }

var oldint1c : pm_addr; { 48 bit pointer to old interrupt handler }
    newint1c : pm_addr; { 48 bit pointer to new interrupt handler }

    int1c_counter : Longint; { increased every time the interrupt is called  }


{ the actual handler code }
procedure int1c_handler; assembler;
asm
   cli
{ save all registers }
   pushw %ds
   pushw %ax
{ prepare segment registers for FPC procedure }
   movw ___v2prt0_ds_alias, %ax
   movw %ax, %ds
{ simply increase the counter by one }
   incl _INT1C_COUNTER
{ restore registers }
   popw %ax
   popw %ds
   sti
   iret
end;

begin
     { insert right handler data into new handler variable }
     newint1c.offset := DWord(@int1c_handler);
     newint1c.selector := cseg;
     { get the old handler }
     dpmi_get_pm_interrupt(int1c, oldint1c);
     Writeln('-- Press any key to exit --');
     { set new handler }
     dpmi_set_pm_interrupt(int1c, newint1c);
     { write the number of interrupts occured }
     while (not keypressed) do begin
           gotoxy(1, wherey); write('Number of interrupts occured : ', int1c_counter);
     end;
     { restore old handler }
     dpmi_set_pm_interrupt(int1c, oldint1c);
end.
