{ example for
           meminfobuf record
	   example for error handling
           dpmi_get_free_memory_information()
           dpmi_get_page_size()


This demo (C) 1998 by Thomas Schatzl

Author:               Thomas Schatzl
License               LGPL, see the file docs/COPYING.TXT, included in
                      this distribution for details about the copyright.
Description           Shows how to obtain memory information via
                      get_meminfo();

  notice the checks if any of the returned information is invalid (-1)
}

uses dpmi;

var meminfo : meminfobuf;
    page_size : DWord;

begin
     dpmi_get_free_memory_information(meminfo);
     if (dpmi_error <> 0)  then begin
        Writeln('Error getting DPMI memory information... Halting');
        Writeln('DPMI error number : ', dpmi_error);
     end else begin
         dpmi_get_page_size(page_size);
         with meminfo do begin
              Writeln('Largest available free block : ', largest_available_free_block div 1024, ' kbytes');
              if (max_unlocked_pages <> -1) then
                 Writeln('Maximum available unlocked pages : ', max_unlocked_pages);
              if (max_lockable_pages <> -1) then
                 Writeln('Maximum lockable available pages : ', max_lockable_pages);
              if (linear_address_space_size <> -1) then
                 Writeln('Linear address space size : ', linear_address_space_size*page_size div 1024, ' kbytes');
              if (number_of_unlocked_pages <> -1) then
                 Writeln('Total number of unlocked pages : ', number_of_unlocked_pages);
              if (number_of_free_pages <> -1) then
                 Writeln('Total number of free pages : ', number_of_free_pages);
              if (number_of_physical_pages <> -1) then
                 Writeln('Total number of physical pages : ', number_of_physical_pages);
              if (free_linear_address_space <> -1) then
                 Writeln('Free linear address space : ', free_linear_address_space*page_size div 1024, ' kbytes');
              if (size_of_paging_file <> -1) then
                 Writeln('Maximum size of paging file : ', size_of_paging_file*page_size div 1024, ' kbytes');
         end;
     end;
end.