{ This demo (C) 1998 by Thomas Schatzl

Author:               Thomas Schatzl
License               LGPL, see the file docs/COPYING.TXT, included in
                      this distribution for details about the copyright.
Description           This is a simple demonstration program of the
                      "near pointer" feature of the unit. It will switch
                      to Mode 13h and draw random pixels on it.
}



program neartest;

uses dpmi;

var pvga : ^byte;     { near pointer to VGA screen }
    i : DWord;

    r : registers;      { register set used for mode switching }

begin
     dpmi_enable_nearptr; { enable near pointer handling }
     dpmi_nearptr_address_mapping($A000 * 16, $FFFF,  pvga);
     { get near pointer to VGA screen and check if we succeeded in creating
       a pointer to it }
     if (pvga=nil) then begin
        Writeln('Failed to create near pointer.'); halt;
     end;
     
     r.eax := $13; realintr($10, r); { switch to Mode 13h (VGA, 320x200x8bit) }

     randomize;

     i := 0;
     for i := 0 to $FFFFF do
         (pvga + random(320) + random(200) * 320)^ := random(256);

     readln;

     r.eax := $3; realintr($10, r); { and finally back to textmode }
     
     Writeln('Just drew ', i,' random pixels');
     dpmi_disable_nearptr;
end.