{ example for :
          Selectors and descriptors
          dpmi_segment_to_descriptor()
          seg_memset()
          realintr()
          registers record

This demo (C) 1998 by Thomas Schatzl

Author:               Thomas Schatzl
License               LGPL, see the file docs/COPYING.TXT, included in
                      this distribution for details about the copyright.
Description           This example demonstrates the use of the
                      segment_to_descriptor() function.

  It switches to VGA mode 13h (320x200x256 color), creates a selector to the
  memory (based at $A000:0000), clears this memory with color 15 (white) and
  waits until the enter key is pressed
}

uses memory, dpmi;

var vgasel : Word;
    r : registers;

begin
     { set VGA mode 13h }
     r.eax := $13; realintr($10, r);
     { allocate descriptor to VGA memory quickly; it could be done with
       create_selector() too, but we would have to initialize it
       by ourselves... unlike segment_to_descriptor() which automatically sets
       the limit and the base address correctly }
     dpmi_segment_to_descriptor($A000, vgasel);
     { simply fill the screen memory with color 15 }
     seg_memsetb(vgasel, 0, 64000, 15);
     { wait for a return press }
     readln;
     { back to text mode }
     r.eax := $3; realintr($10, r);
     { don't deallocate vgasel, that shouldn't be done, because we got it via
       dpmi_segment_to_descriptor() }
end.